<?php
/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this application in the file LICENSE.txt.
 *
 * @version    $Id: Articles.php 3439 2013-06-12 13:15:07Z pavel.iacovlev $
 * @category   Giscuit
 * @package    Giscuit_Form
 * @subpackage Admin
 * @copyright  Copyright (c) 2012 VEC
 */

/**
 * @see Zend_Form
 */
require_once 'Zend/Form.php';

/**
 * Article form class
 * 
 * @category   Giscuit
 * @package    Giscuit_Form
 * @subpackage Admin
 * @copyright  Copyright (c) 2012 VEC
 */
class Giscuit_Form_Admin_Articles extends Giscuit_Form_Abstract
{
    /**
     * Initialize
     *
     * @return void
     */
    public function init ()
    {
        $languages = Zend_Registry::get('config')->language->toArray();
        
        foreach ($languages as $key => $language) {
            
            $this->addElement('text', 'title_' . $key, array(
                'filters' => array() , 
                'validators' => array(
                    array(
                        'StringLength' , 
                        false , 
                        3
                    )
                ) , 
                'required' => false , 
                'label' => 'title'
            ));
            
            $this->addElement('text', 'tags_' . $key, array(
                'filters' => array() , 
                'validators' => array(
                    array(
                        'StringLength' , 
                        false , 
                        3
                    )
                ) , 
                'required' => false , 
                'label' => 'tags'
            ));
            
            $this->addElement('textarea', 'desc_' . $key, array(
                'filters' => array() , 
                'validators' => array(
                    array(
                        'StringLength' , 
                        false , 
                        3
                    )
                ) , 
                'required' => false , 
                'label' => 'desc' , 
                'rows' => 5
            ));
            
            $this->addElement('textarea', 'text_' . $key, array(
                'filters' => array() , 
                'validators' => array(
                    array(
                        'StringLength' , 
                        false , 
                        3
                    )
                ) , 
                'required' => false , 
                'label' => 'text' , 
                'rows' => 5
            ));
        }
        
        $this->addElement('checkbox', 'active', array(
            'filters' => array() , 
            'validators' => array(
                array(
                    'InArray' , 
                    false , 
                    array(
                        array(
                            't' , 
                            'f'
                        )
                    )
                )
            ) , 
            'required' => true , 
            'label' => 'active' , 
            'checkedValue' => 't' ,
            'uncheckedValue' => 'f'
        ));
        
        $this->addElement('date', 'created_date', array(
            'label' => 'created_date' , 
        ));
        
        $this->addElement('button', 'submit_button', array(
            'ignore' => true , 
            'label' => 'submit' ,
            'id' => 'submit_button' , 
        ));
        
        $this->addDecorators(array(
            array(
                'viewScript' , 
                array(
                    'viewScript' => 'forms' . DIR_SEP . 'articles' . GT_SCRIPT_EXT
                )
            )
        ));
        
        $this->setAttrib('enctype', 'multipart/form-data');
    }

}