<?php
/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this application in the file LICENSE.txt.
 *
 * @version    $Id: Symbols.php 2644 2012-05-07 12:25:16Z pavel.iacovlev $
 * @category   Giscuit
 * @package    Giscuit_Form
 * @subpackage Admin
 * @copyright  Copyright (c) 2012 VEC
 */

/**
 * @see Zend_Form
 */
require_once 'Zend/Form.php';

/**
 * Symbols form class
 * 
 * @category   Giscuit
 * @package    Giscuit_Form
 * @subpackage Admin
 * @copyright  Copyright (c) 2012 VEC
 */
class Giscuit_Form_Admin_Symbols extends Giscuit_Form_Abstract
{

    /**
     * Initialize
     *
     * @return void
     */
    public function init ()
    {
        $content = file_get_contents(GT_CONFIG_PATH . DIR_SEP . 'symbols.sym');
        
        $this->addElement('textarea', 'content' , array(
            'required' => true , 
            'decorators' => array(
                'ViewHelper'
            ),
            'value' => $content ,
            'rows' => 20
        ));
        
        //Submit
        $this->addElement('button', 'submit_button', array(
            'required' => false , 
            'ignore' => true , 
            'label' => 'save' , 
            'id' => 'symbolsSubmit'
        ));
    
    }

}