<?php
/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this application in the file LICENSE.txt.
 *
 * @version    $Id: Login.php 2644 2012-05-07 12:25:16Z pavel.iacovlev $
 * @category   Giscuit
 * @package    Giscuit_Form
 * @copyright  Copyright (c) 2012 VEC
 */

/**
 * @see Giscuit_Form_Abstract
 */
require_once 'Giscuit/Form/Abstract.php';

/**
 * Authentication form class
 * 
 * @category   Giscuit
 * @package    Giscuit_Form
 * @copyright  Copyright (c) 2012 VEC
 */
class Giscuit_Form_Login extends Giscuit_Form_Abstract
{
    /**
     * Initialize
     *
     * @return void
     */
    public function init ()
    {
        //
        $this->setMethod('post');
        $this->addAttribs(array(
            'id' => 'gtAuthLoginForm' 
        ));
        
        //Account
        $this->addElement('text', 'account', array(
            'filters' => array(
                'StringTrim'
            ) , 
            'validators' => array(
                array(
                    'EmailAddress'
                )
            ) , 
            'required' => true , 
            'label' => 'account'
        ));
        
        //Password
        $this->addElement('password', 'password', array(
            'validators' => array(
                array(
                    'StringLength' , 
                    false , 
                    array(
                        6 , 
                        32
                    )
                )
            ) , 
            'required' => true , 
            'label' => 'password'
        ));
        
        //Submit
        $this->addElement('submit', 'submit_button', array(
            'attribs' => array(
                'id' => 'gtAuthLoginSubmit'
            ) , 
            'required' => false , 
            'ignore' => true , 
            'label' => 'login'
        ));
    
    }
}