<?php
/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this application in the file LICENSE.txt.
 *
 * @version    $Id: FormFile.php 3228 2012-12-24 16:06:01Z pavel.iacovlev $
 * @category   Giscuit
 * @package    Giscuit_View_Helper
 * @copyright  Copyright (c) 2012 VEC
 */

/**
 * Add hidden element to a file element
 * 
 * @category   Giscuit
 * @package    Giscuit_View_Helper
 * @copyright  Copyright (c) 2012 VEC
 */
class Giscuit_View_Helper_FormFile extends Zend_View_Helper_FormElement
{
    public function formFile($name, $attribs = null)
    {
        $xhtml = '';
        
        $info = $this->_getInfo($name, null, $attribs);
        extract($info); // name, id, value, attribs, options, listsep, disable

        // is it disabled?
        $disabled = '';
        if ($disable) {
            $disabled = ' disabled="disabled"';
        }
        
        //
        if(! isset($attribs['data-file-id'])) {
            $attribs['data-file-id'] = '';
        }
        $fileId = $attribs['data-file-id'];
        
        //Hidden
        $xhtml .= $this->_hidden('__fileid_' . $name, $fileId);
        
        //File
        $xhtml .= '<input type="file"'
                . ' name="' . $this->view->escape($name) . '"'
                . ' id="' . $this->view->escape($id) . '"'
                . $disabled
                . $this->_htmlAttribs($attribs)
                . $this->getClosingBracket();
        
        //Delete
        if($fileId) {
            $translate = Zend_Registry::get('Zend_Translate');
            $deleteTitle = $translate->_('delete');
            $xhtml .= "<a class=\"file-delete\" data-role=\"button\" data-icon=\"delete\" data-iconpos=\"notext\" title=\"$deleteTitle\"></a>";  
        }
        
        return $xhtml;
    }
}
