/**
 * Admin javascript code for categories
 */

var jobsBuildHtml = function () {
    var css = '.jobsUpArrow span button {background: url("' + gt.config.httpImagePath + '/up.png") no-repeat scroll 50% 50% transparent;}' +
        '.jobsDownArrow span button {background: url("' + gt.config.httpImagePath + '/down.png") no-repeat scroll 50% 50% transparent;}' +
        '.jobsLeftDiv {float: left; width: 40%;}' +
        '.jobsRightDiv {float:left; width: 60%;}';

    var styleSheet = new YAHOO.util.StyleSheet(css, 'jobsAdminCss');
    
    var html = '<div id="jobsWorkflowDiv" class="jobsLeftDiv">' +
        '<label for="jobsWorkflowDt"><b>' + gt.translate._('Workflows') + '</b></label>' +
        '<div id="jobsWorkflowDt"></div>' +
        '<button type="button" id="jobsWorkflowsAddButton">' + gt.translate._('add') + '</button>' + 
        '<button type="button" id="jobsWorkflowsDeleteButton">' + gt.translate._('delete') + '</button>' + 
    '</div>' +
    '<div id="jobsActionsDiv" class="jobsRightDiv">' +
        '<label for="jobsActionsDt"><b>' + gt.translate._('Actions') + '</b></label>' +
        '<div id="jobsActionsDt"></div>' +
        '<button type="button" id="jobsActionsAddButton">' + gt.translate._('add') + '</button>' + 
        '<button type="button" id="jobsActionsDeleteButton">' + gt.translate._('delete') + '</button>' + 
        '<span id="jobsActionsUpButton" class="yui-button yui-push-button jobsUpArrow"><span class="first-child"><input type="button"></span></span>' +
        '<span id="jobsActionsDownButton" class="yui-button yui-push-button jobsDownArrow"><span class="first-child"><input type="button"></span></span>' +
    '</div>' +
    '<div style="clear: both;"></div><br>';
    
    YAHOO.util.Dom.get("jobsDiv").innerHTML = html;
}

var jobsCreateDatatables = function () {
    var jobWorkflowsPerPage = 10;
    var jobActionsPerPage = 10;
    var actionsDt;

    //Create workflows datatable
    var workflowsFieldsArr = ['id', 'name_id'];
    for (var langKey in pluginLanguageObj) {
        workflowsFieldsArr.push('name_' + langKey);
    }
    
    var workflowsColumnsArr = [{key: "id", label: gt.translate._('id'), sortable: true}, 
        {key: "name_id", label: gt.translate._('name_id'), hidden: true}
    ];
    
    for (var langKey in pluginLanguageObj) {
        var columnObj = {};
        columnObj.key = 'name_' + langKey;
        columnObj.resizeable = true;
        columnObj.editor = "textbox";
        columnObj.label = pluginLanguageObj[langKey];
        workflowsColumnsArr.push(columnObj);
    }
    
    var workflowsOptions = {
        fields : workflowsFieldsArr ,
        columnDefs : workflowsColumnsArr,
        selectionMode: "single",
        dataUrl : gt.config.httpToolPath + '/jobs/getworkflows' ,
        dataSourceType: YAHOO.util.DataSource.TYPE_JSON ,
        addDataUrl : gt.config.httpToolPath + '/jobs/addworkflow' ,
        updateDataUrl : gt.config.httpToolPath + '/jobs/updateworkflow' ,
        deleteDataUrl : gt.config.httpToolPath + '/jobs/deleteworkflow' ,
        container : 'jobsWorkflowDt' ,
        rowsPerPage : jobWorkflowsPerPage ,
        keyColumn : 'id'
    };  

    var workflowsDt = new Giscuit.Datatable(workflowsOptions);

    workflowsDt.editRow = function (oArgs) {
        var column = oArgs.editor.getColumn().key;
        var data = oArgs.newData;
        var id = oArgs.editor.getRecord().getData('name_id');
        
        var params = 'data=' + data + '&id=' + id + '&column=' + column;
        var url = this.options.updateDataUrl;

        YAHOO.util.Connect.asyncRequest('POST', url, {
            success: function (o) {
                try {
                    var responseText = YAHOO.lang.JSON.parse(o.responseText);
                } catch(e) {
                    Giscuit.Util.parseFailure(o, e);
                    return;
                }
                
                if (responseText.replyCode != 200) {
                    Giscuit.Util.invalidReplyCode(responseText);
                    return;
                }                
            },
            failure: Giscuit.Util.callbackFailure,
            scope: this
        }, params);
    };
    
    workflowsDt.addButton = new YAHOO.widget.Button("jobsWorkflowsAddButton");
    workflowsDt.deleteButton = new YAHOO.widget.Button("jobsWorkflowsDeleteButton");
    
    workflowsDt.options.onRowAdd.subscribe(function () {
        YAHOO.util.Connect.asyncRequest('POST', workflowsDt.options.addDataUrl, {
            success: function (o) {
                try {
                    var responseText = YAHOO.lang.JSON.parse(o.responseText);
                } catch(e) {
                    Giscuit.Util.parseFailure(o, e);
                    return;
                }
                
                if (responseText.replyCode != 200) {
                    Giscuit.Util.invalidReplyCode(responseText);
                    return;
                }

                workflowsDt.dt.addRow(responseText.record);
                workflowsDt.dt.get('paginator').setPage(workflowsDt.dt.get('paginator').getTotalPages());
            },
            failure: function (o) {
                Giscuit.Util.callbackFailure(o);
            },
            scope: this
        });
    }, null, this);
    
    workflowsDt.initialize();
    
    workflowsDt.dt.subscribe("rowDeleteEvent", function() {
        var count = actionsDt.dt.getRecordSet().getLength();
        actionsDt.dt.deleteRows(0, count);
        actionsDt.addButton.set('disabled', true);
    }, null, this);
    
    workflowsDt.options.onCellClick.subscribe(function() {
        var row = workflowsDt.dt.getSelectedRows();
        if (row[0] == undefined) {
            return;
        }

        var id = workflowsDt.dt.getRecord(row[0]).getData(workflowsOptions.keyColumn);
        
        //Enable add button
        actionsDt.addButton.set('disabled', false);

        //Modify addDataUrl
        actionsOptions.addDataUrl = gt.config.httpToolPath + '/jobs/addaction/workflowId/' + id;
        
        //Request new data
        actionsDt.ds.sendRequest('/id/' + id, actionsDt.dt.onDataReturnInitializeTable, actionsDt.dt);
    }, null, this); 
    
    //Create actions datatable
    var themesArr = [{label: gt.translate._('Black'), value: "a"},
        {label: gt.translate._('Blue'), value: "b"},
        {label: gt.translate._('Light gray'), value: "c"},
        {label: gt.translate._('Dark gray'), value: "d"},
        {label: gt.translate._('Golden'), value: "e"}
    ];
    
    var parentEditor = new YAHOO.widget.CheckboxCellEditor({checkboxOptions: [{label:"", value: ""}]});
    parentEditor.subscribe("showEvent", function(oArgs) {
        //Don't edit accept and decline parents
        var reserved = parseInt(oArgs.editor.getRecord().getData('reserved'));
        if (reserved == 1 || reserved == 2) {
            oArgs.editor.cancel();
            return;
        }
        
        var records = actionsDt.dt.getRecordSet().getRecords();
        var options = [];
        for (var i = 0; i < records.length; i++) {
            var labelText = records[i].getData('name_en') ? records[i].getData('name_en') : '';
            options.push({
                label: labelText,
                value: records[i].getData('id')
            });
        }
        
        oArgs.editor.checkboxOptions = options;
        oArgs.editor._elContainer.innerHTML = '';
        oArgs.editor.renderForm();
        oArgs.editor.renderBtns();
        oArgs.editor.resetForm();
    }, null, this);
    
    var parentFormatter = function(elCell, oRecord, oColumn, oData) {
        if (typeof(oData) == 'undefined') {
            elCell.innerHTML = '';
        } else {
            var records = actionsDt.dt.getRecordSet().getRecords();
            var selectedParents = [];
            for (var i = 0; i < records.length; i++) {
                var actionId = records[i].getData('id');
                for (var j = 0; j < oData.length; j++) {
                    if (actionId == oData[j]) {
                        selectedParents.push(records[i].getData('name_en'));
                        break;
                    }
                }
            }
            
            elCell.innerHTML = selectedParents.join(',');
        }
    };
    
    var parseParent = function(data) {
        return data.split(',');
    };
    
    var idFormatter = function(elCell, oRecord, oColumn, oData) {
        if (oRecord.getData('reserved')) {
            elCell.style.color = '#CC0000';
        }
        elCell.innerHTML = oData;
    };
    
    var actionsFieldsArr = ['id', 'name_id', "order", "theme", "reserved", {key: "parent", parser: parseParent}];
    for (var langKey in pluginLanguageObj) {
        actionsFieldsArr.push('name_' + langKey);
    }
    
    var actionsColumnsArr = [{key: "id", label: gt.translate._('id'), formatter: idFormatter, sortable: true}];
    
    for (var langKey in pluginLanguageObj) {
        var columnObj = {};
        columnObj.key = 'name_' + langKey;
        columnObj.resizeable = true;
        columnObj.editor = "textbox";
        columnObj.label = pluginLanguageObj[langKey];
        actionsColumnsArr.push(columnObj);
    }
    
    actionsColumnsArr.push({
        key: "theme" , 
        resizeable:true , 
        sortable:true , 
        editor: new YAHOO.widget.DropdownCellEditor({dropdownOptions: themesArr}),
        formatter: function(a, b, c) {
            for(var i=0; i < themesArr.length; i++) {
                if(themesArr[i].value == b.getData(c.field)) {
                    a.innerHTML = themesArr[i].label;
                    break;
                }
            }
        } ,
        label: gt.translate._('theme')
    });
    actionsColumnsArr.push({
        key: "parent" , 
        resizeable: true , 
        sortable: true ,
        editor: parentEditor,
        formatter: parentFormatter,
        label: gt.translate._('parent')
    });
    
    var actionsOptions = {
        fields : actionsFieldsArr ,
        columnDefs : actionsColumnsArr,
        selectionMode: "single",
        initialLoad: false,
        dataUrl : gt.config.httpToolPath + '/jobs/getactions' ,
        dataSourceType: YAHOO.util.DataSource.TYPE_JSON ,
        addDataUrl : gt.config.httpToolPath + '/jobs/addaction' ,
        updateDataUrl : gt.config.httpToolPath + '/jobs/updateaction' ,
        deleteDataUrl : gt.config.httpToolPath + '/jobs/deleteaction' ,
        moveDataUrl : gt.config.httpToolPath + '/jobs/moveaction' ,
        container : 'jobsActionsDt' ,
        rowsPerPage : jobActionsPerPage ,
        keyColumn : 'id'
    };  

    actionsDt = new Giscuit.Datatable(actionsOptions);

    actionsDt.editRow = function (oArgs) {
        var column = oArgs.editor.getColumn().key;
        var data = oArgs.newData;

        if (column == 'theme' || column == 'parent') {
            var id = oArgs.editor.getRecord().getData(this.options.keyColumn);
        } else {
            var id = oArgs.editor.getRecord().getData('name_id');
        }
        
        var params = 'data=' + data + '&id=' + id + '&column=' + column;
        var url = this.options.updateDataUrl;

        YAHOO.util.Connect.asyncRequest('POST', url, {
            success: function (o) {
                try {
                    var responseText = YAHOO.lang.JSON.parse(o.responseText);
                } catch(e) {
                    Giscuit.Util.parseFailure(o, e);
                    return;
                }
                
                if (responseText.replyCode != 200) {
                    Giscuit.Util.invalidReplyCode(responseText);
                    return;
                }                
            },
            failure: Giscuit.Util.callbackFailure,
            scope: this
        }, params);
    };
    
    actionsDt.addButton = new YAHOO.widget.Button("jobsActionsAddButton");
    actionsDt.addButton.set('disabled', true);
    
    actionsDt.deleteButton = new YAHOO.widget.Button("jobsActionsDeleteButton");
    actionsDt.deleteButton.set('disabled', true);
    
    actionsDt.moveupButton = new YAHOO.widget.Button('jobsActionsUpButton');
    actionsDt.moveupButton.set('disabled', true);
    
    actionsDt.movedownButton = new YAHOO.widget.Button('jobsActionsDownButton');
    actionsDt.movedownButton.set('disabled', true);
    
    actionsDt.options.onRowAdd.subscribe(function () {
        YAHOO.util.Connect.asyncRequest('POST', actionsDt.options.addDataUrl, {
            success: function (o) {
                try {
                    var responseText = YAHOO.lang.JSON.parse(o.responseText);
                } catch(e) {
                    Giscuit.Util.parseFailure(o, e);
                    return;
                }
                
                if (responseText.replyCode != 200) {
                    Giscuit.Util.invalidReplyCode(responseText);
                    return;
                }

                actionsDt.dt.addRow(responseText.record);
                actionsDt.dt.get('paginator').setPage(actionsDt.dt.get('paginator').getTotalPages());
            },
            failure: function (o) {
                Giscuit.Util.callbackFailure(o);
            },
            scope: this
        });
    }, null, this);
    
    actionsDt.initialize();
    
    actionsDt.options.onCellClick.subscribe(function() {
        var row = actionsDt.dt.getSelectedRows();
        if (row[0] == undefined) {
            return;
        }

        var reserved = parseInt(actionsDt.dt.getRecord(row[0]).getData('reserved'));
        if (reserved == 1 || reserved == 2 || reserved == 3) {
            actionsDt.deleteButton.set('disabled', true);
        }

    }, null, this); 
}

jobsBuildHtml();
jobsCreateDatatables();