/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this package in the file LICENSE.txt.
 *
 * @version    $Id: Csw.js 2644 2012-05-07 12:25:16Z pavel.iacovlev $
 * @copyright  Copyright (c) 2012 VEC
 */
Giscuit.Map.prototype.gtEventListeners.push({
    'draw': function() {
        gt.control.csw = new Giscuit.Control.Csw();
    }
});
toolTip = function() {
    
};

/**
 * Class: Giscuit.Control.Csw
 * 
 *  Inherits from:
 *   - <Giscuit.Control>
 */
Giscuit.Control.Csw = OpenLayers.Class(Giscuit.Control, {
   
    panel: null,
    
    button: null,
    
    categories: [],
    
    submitButton: null,
    
    backButton: null,
    
    homeButton: null,
    
    bounds: [],
    
    highlightControl: null,
    
    selectControl: null,
    
    serverUrl: null,
    
    brand: null,
    
    history: [],
    
    
    records: [],
    
    recordsTotal: null,
    
    recordsPerPage: 10,
    
    recordsPaginator: null,
    
    catalogMenuItem: null,
    
    mapMenuItem: null,
    
    initialize: function (options) {
        //
        Giscuit.Control.prototype.initialize.apply(this, [options]);
        var self = this;
        
        //Activate control on "Catalog" menu item click
        var nodes = YAHOO.util.Selector.query('a', YAHOO.util.Dom.get('gtNavigation'));
        for(var i = 0; i < nodes.length; i++) {
            if(nodes[i].href.search('default/map#ac=csw') > 0) {
                
                this.catalogMenuItem = nodes[i];
                YAHOO.util.Event.addListener(this.catalogMenuItem, "click", function(evt) {
                    YAHOO.util.Event.preventDefault(evt);
                    
                    if(this.active) {
                        gt.layer.vector.destroyFeatures(this.bounds);
                        this.bounds = [];
                        
                        this.loadRecords({name: 'latest'});
                    } else {
                        this.activate();
                    }
                    
                    return false;
                }, null, this);
                
                break;
            }
        }

        //Save plugin params
        this.serverUrl = gt.pluginParams.cswUrl;
        this.brand = gt.pluginParams.cswBrand;
        
        //Normalize server URL
        if(this.serverUrl.slice(-2) == '/?') {
            this.serverUrl = this.serverUrl.slice(0, -2);
        }
        if(this.serverUrl.slice(-1) == '/' || this.serverUrl.slice(-1) == '?') {
            this.serverUrl = this.serverUrl.slice(0, -1);
        }
        this.serverUrl = this.serverUrl.replace('<locale>', gt.config.locale);
        
        //
        this.highlightControl = new OpenLayers.Control.SelectFeature(gt.layer.vector, {
            hover: true,
            highlightOnly: true,
            eventListeners: {
                featurehighlighted: function(evt) {
                    evt.feature.styleMap.styles.select.defaultStyle.label = evt.feature.attributes.title;
                    evt.feature.layer.redraw();
                }
            }
        });
        gt.map.addControl(this.highlightControl);
        
        //
        this.selectControl = new OpenLayers.Control.SelectFeature(gt.layer.vector, {
            clickout: true,
            eventListeners: {
                featurehighlighted: function(evt) {
                    self.loadRecords({
                        name: 'record', value:evt.feature.attributes.id
                    });
                }
            }
        });
        gt.map.addControl(this.selectControl);
        
        //Add css
        var css = '#gtCswNavigation {position: absolute; right: -1px; top: -1px;}' +
            '#gtCswCategories {margin-top: 5px;}' +
            
            '#gtCswRecordsList {padding:0; margin:0;}' +
            '#gtCswRecordsList li {border-bottom: 1px solid #DDD; list-style-type: none;}' +
            '#gtCswRecordsList li span {padding: 5px;}' +
            '#gtCswRecordsList li span img {cursor: pointer;}' +
            
            '#gtCswRecord > h2 {clear: both; cursor: pointer;}' + 
            '#gtCswRecord > h2.toggle span {display: inline-block; margin-left: 5px; width: 14px; height: 14px;}' +
            '#gtCswRecord > h2.toggle.off span {background: url(' + gt.config.httpImagePath + '/../yui/build/assets/skins/sam/sprite.png) 0 -350px;}' +
            '#gtCswRecord > h2.toggle.on span {background: url(' + gt.config.httpImagePath + '/../yui/build/assets/skins/sam/sprite.png) 0 -400px;}' +
            
            '#gtCswRecord > ul {padding:0; margin:0; margin-bottom:1em;}' +
            '#gtCswRecord > ul > li {border-top: 1px solid #DDD; clear: both;  list-style-type: none;}' +
            '#gtCswRecord > ul > li .name {width: 20%; float:left; padding: 7px;}' +
            '#gtCswRecord > ul > li .value {width: 70%; float:left; padding: 7px;}' +
            '#gtCswRecord > ul > li .value.uri ul {margin:0; margin-left: 1em;}' +
            
            '#gtCswRecordExtended .md, #gtCswRecordExtended .padded {text-align: left; padding: 3px;}' +
            '#gtCswRecordExtended fieldset {border: 1px solid gray; padding: 3px; margin: 5px;}' +
            '#gtCswRecordExtended .no-help {color: #000;}' + 
            '#gtCswRecordExtended th, #gtCswRecordExtended td {border: 0;}';
            
        var styleSheet = new YAHOO.util.StyleSheet(css, this.CLASS_NAME);
    },
    
    mapMenuClick: function(evt) {
        YAHOO.util.Event.preventDefault(evt);
        
        if(this.active) {
            this.clear();
        } else {
            window.location = this.mapMenuItem.href;
        }
                        
        return false;
    },
    
    activate: function () {
        var self = this;
        
        var activated = Giscuit.Control.prototype.activate.call(this);
        
        if (activated == true) {
            //
            gt.map.globalSelectControl.deactivate();
            this.highlightControl.activate();
            this.selectControl.activate();

            //Clear control on "Map" menu item click
            var nodes = YAHOO.util.Selector.query('a', YAHOO.util.Dom.get('gtNavigation'));
            for(var i = 0; i < nodes.length; i++) {
                if(nodes[i].href.search(/default\/map$/) > 0) {
                    this.mapMenuItem = nodes[i];
                    
                    YAHOO.util.Event.removeListener(this.mapMenuItem, "click", this.mapMenuClick);
                    YAHOO.util.Event.addListener(this.mapMenuItem, "click", this.mapMenuClick, null, this);
                    
                    break;
                }
            }
            
            //
            gt.init.openCenterView('top');
            
            //
            this.create();

            var hashObj = Giscuit.Util.getHash();
            if (typeof(hashObj.csw) != 'undefined') {
                this.loadRecords({name: 'record', value: hashObj.csw});
            } else {
                this.loadRecords({name: 'latest'});
            }
        } else {
            gt.accord.openPanel(this.getPanelIndex());
        }
        
        return activated;
    },
    
    deactivate: function () {
        var deactivated = Giscuit.Control.prototype.deactivate.call(this);

        if (deactivated == true) {
            //
            gt.layer.vector.destroyFeatures(this.bounds);
            this.bounds = [];
        }
        
        return deactivated;
    },

    clear: function () {
        this.deactivate();
        
        //
        YAHOO.util.Event.removeListener(this.mapMenuItem, "click", this.mapMenuClick);
        
        //
        this.highlightControl.deactivate();
        this.selectControl.deactivate();
        gt.map.globalSelectControl.activate();
        
        //
        gt.init.closeCenterView();
    },
    
    create: function() {
        //Create panel
        if (this.panel == null) {
            gt.accord.addPanel({
                label: gt.translate._('catalog') ,
                content: this.getLoadingImage()
            });
            this.panel = gt.accord.getPanel(gt.accord.getPanels().length - 1);
            this.addHelpButton('http://docs.giscuit.com/En/tutorial_refguide.user.desktop.csw.pkg.html');
        } else {
            gt.accord.setBody(this.getPanelIndex(), this.getLoadingImage());
        }
        
        gt.accord.openPanel(this.getPanelIndex());
        YAHOO.util.Event.purgeElement('gtCenterView', true);
        
        //Create panel content
        var html = '<form id="gtCswForm"><dl class="zend_form">' +
        '<dt id="gtCswSearch-label">' +
            '<label class="optional" for="gtCswSearch">' + gt.translate._('what') + '</label>' +
        '</dt>' +
        '<dd id="gtCswSearch-element">' +
            '<input id="gtCswSearch" type="text" onkeypress="return event.keyCode != 13">' +
        '</dd>' +
        '<dt id="gtCswWhere-label">' +
            '<label class="optional">' + gt.translate._('where') + '</label>' +
        '</dt>' +
        '<dd id="gtCswWhere-element">' +
            '<label for="gtCswWhere-everywhere">' +
                '<input id="gtCswWhere-everywhere" type="radio" checked="checked" value="everywhere" name="where">' + 
                gt.translate._('everywhere') + 
            '</label>' +
            '<br>' +
            '<label for="gtCswWhere-bbox">' +
                '<input id="gtCswWhere-bbox" type="radio" value="bbox" name="where">' + 
                gt.translate._('withInCurrentBbox') + 
            '</label>' +
        '</dd>' +
        '<dt id="gtCswSort-label">' +
            '<label class="optional">' + gt.translate._('sort') + '</label>' +
        '</dt>' +
        '<dd id="gtCswSort-element">' +
            '<label for="gtCswSort-alpha">' +
                '<input id="gtCswSort-alpha" type="radio" checked="checked" value="alpha" name="sort">' + 
                gt.translate._('alphabetically') + 
            '</label>' +
            '<br>' +
            '<label for="gtCswSort-asc">' +
                '<input id="gtCswSort-asc" type="radio" value="asc" name="sort">' + 
                gt.translate._('newestFirst') + 
            '</label>' +
            '<br>' +
            '<label for="gtCswSort-desc">' +
                '<input id="gtCswSort-desc" type="radio" value="desc" name="sort">' + 
                gt.translate._('oldestFirst') + 
            '</label>' +
        '</dd>' +
        '<button type="button" id="gtCswSubmit">' + gt.translate._('search') + '</button>' +
        '</dl></form>';
        
        gt.accord.setBody(this.getPanelIndex(), html);
        
        this.submitButton = new YAHOO.widget.Button('gtCswSubmit');
        this.submitButton.on("click", function () {
            this.submitButton.set('disabled', true);
            
            //
            if(! this.active) {
                this.activate();
            }
            
            //Reset
            //this.recordsStartPosition = 1;
            var el = YAHOO.util.Dom.get('gtCswRecordsList');
            if(el) {
                el.parentNode.removeChild(el);
            }
            
            //Sort by
            var sort = '';
            if (YAHOO.util.Dom.get('gtCswSort-alpha').checked) {
                sort = 'alpha';
            } else if (YAHOO.util.Dom.get('gtCswSort-asc').checked) {
                sort = 'asc';
            } else if (YAHOO.util.Dom.get('gtCswSort-desc').checked) {
                sort = 'desc';
            }
            
            //Bbox
            var extent = null;
            if (YAHOO.util.Dom.get('gtCswWhere-bbox').checked) {
                var extent = gt.map.getExtent();
            }
            
            //Search
            this.loadRecords({
                'name': 'search',
                'sort': sort,
                'bbox': extent,
                'text': YAHOO.util.Dom.get('gtCswSearch').value,
                'startPos': 1
            });
        }, null, this);
        
        //Create navigation and content div's
        var cswHtml = '<div id="gtCswNavigation"></div>' +
            '<div id="gtCswContent"></div>';
        
        YAHOO.util.Dom.get('gtCenterView').innerHTML = cswHtml;
        
        //Back button
        var labelHtml = '<em style="background: url(' + gt.config.httpImagePath + '/csw-back.png) 0px center no-repeat; display: block; width:24px; height:28px;">&nbsp;</em>';
        this.backButton = new YAHOO.widget.Button({
            label: labelHtml,
            id: 'gtCswBackButton',
            title: gt.translate._('back'), 
            container: "gtCswNavigation"
        });
        this.backButton.get('element').style.margin = '0px';
        this.backButton.get('element').style.display = 'none';
        this.backButton.on("click", function () {
            this.history.pop();
            var req = YAHOO.lang.JSON.parse(
                YAHOO.lang.JSON.stringify(
                    this.history[this.history.length - 1]
                )
            );
            this.history.pop();
                        
            this.loadRecords(req);
        }, null, this);
    },
    
    loadCategories: function() {
        if(this.categories.length) {
            this.renderCategories();
            return;
        }
        
        var url = gt.config.httpProxyPath + encodeURIComponent(this.serverUrl + '?REQUEST=GetCapabilities&SERVICE=CSW');
        
        OpenLayers.Request.GET({
            'url': url,
            success: function(data) {
                this.categories = [];
                var format = new OpenLayers.Format.XML();
                
                var erroMsg = 'Invalid host';
                if(data.responseText.substring(0, erroMsg.length) == erroMsg) {
                    YAHOO.util.Dom.get('gtCswContent').innerHTML = 'Add ' +
                        data.responseText.substring(erroMsg.length + 2, data.responseText.length - 1) + 
                        ' domain to $allowedDomains array in proxy.php';
                    
                    return;
                }
                
                if(data.responseXML && data.responseXML.documentElement) {
                    var doc = data.responseXML;
                } else {
                    var doc = format.read(data.responseText);
                }
                
                var nodes = format.getElementsByTagNameNS(doc, 'http://www.opengis.net/ows', 'Keyword');
                
                for (var i=0; i < nodes.length; i++) {
                    this.categories.push(nodes[i].childNodes[0].nodeValue);
                }
                
                this.renderCategories();
            },
            failure: this.callbackFailure,
            scope: this
        });
    },
    
    renderCategories: function() {
        var self = this;
        
        var html = '<h2>' + gt.translate._('popularKeywords') + '</h2><ul id="gtCswCategories">';

        for (var i = 0; i < this.categories.length; i++) {
            html += '<li data-key="' + this.categories[i] + '"><a href="javascript:void(0)">' + this.categories[i] + '</a></li>';
        }
        
        html += '</ul>';
        
        YAHOO.util.Event.purgeElement('gtCatalogCategories', true);
        YAHOO.util.Dom.get('gtCatalogCategories').innerHTML = html;
        
        var searchCategory = function (event, matchedEl, container) {
            //Search
            self.loadRecords({
                'name': 'category',
                'value': matchedEl.parentNode.getAttribute('data-key'),
                'startPos': 1
            });
        }
        
        YAHOO.util.Event.delegate("gtCswCategories", "click", searchCategory, "a"); 
    },
    
    loadRecords: function (options) {
        var cswFormat = new OpenLayers.Format.CSWGetRecords();
        var reqType = options.name;
        var reqValue = options.value;
        
        //History
        this.history.push(options);
        if(this.history.length > 1) {
            this.backButton.get('element').style.display = 'block';
        } else {
            this.backButton.get('element').style.display = 'none';
        }
        
        //Clear hash
        var hashObj = Giscuit.Util.getHash();
        if (typeof(hashObj.csw) != 'undefined') {
            delete hashObj.csw;
        }
        if (hashObj.ac == 'csw') {
            delete hashObj.ac;
        }
        Giscuit.Util.setHash(hashObj);
        
        if (reqType == 'latest') {
            //
            gt.layer.vector.destroyFeatures(this.bounds);
            this.bounds = [];
            
            //
            var welcomeMessage = gt.translate._('welcomeMessage').replace('%1$s', this.serverUrl);
            var html = '<h1>' + gt.translate._('catalog') + '</h1><p>' + welcomeMessage + '</p>' +
                '<div class="yui-g">' +
                '<div id="gtCatalogCategories" class="yui-u first">' + this.getLoadingImage() + '</div>' +
                '<div id="gtCatalogLatest" class="yui-u">' + this.getLoadingImage() + '</div>' +
                '</div>';
            YAHOO.util.Event.purgeElement('gtCswContent', true);
            YAHOO.util.Dom.get('gtCswContent').innerHTML = html;
            
            //
            this.loadCategories();
            
            var cswData = cswFormat.write({
                resultType: "results",
                startPosition: 1,
                maxRecords: 10,
                "Query": {
                    ElementSetName: {
                        value: "full"
                    },
                    "SortBy": [{
                        "property": 'modified',
                        "order": "DESC"
                    }]  
                }
            });
        } else if (reqType == 'search') {
            var queryObj = {
                'ElementSetName': {value: "full"},
                'SortBy': [],
                'Constraint': {}
            };
            
            //Sort by
            if (options.sort == 'alpha') {
                queryObj.SortBy.push({
                    "order": 'ASC',
                    "property": 'title'
                });
            } else if (options.sort == 'asc') {
                queryObj.SortBy.push({
                    "property": 'modified',
                    "order": 'DESC'
                });
            } else if (options.sort == 'desc') {
                queryObj.SortBy.push({
                    "property": 'modified',
                    "order": 'ASC'
                });
            }
            
            //
            var cswData = cswFormat.write({
                resultType: "results",
                startPosition: options.startPos,
                maxRecords: this.recordsPerPage,
                "Query": queryObj
            });
                        
            //Filter for bbox
            var filterBoundingBox = '';
            if (options.bbox) {
                var extent = options.bbox;
                
                filterBoundingBox += '<ogc:BBOX>' +
                        '<ogc:PropertyName>ows:BoundingBox</ogc:PropertyName>' +
                        '<gml:Envelope>' +
                            '<gml:lowerCorner>' + extent.left + ' ' + extent.bottom + '</gml:lowerCorner>' +
                            '<gml:upperCorner>' + extent.right + ' ' + extent.top + '</gml:upperCorner>' +
                        '</gml:Envelope>' +
                    '</ogc:BBOX>';
            }
            
            //Filter for search
            var filterSearch = '';
            var cswSearchText = options.text;
            if(cswSearchText) {
                cswSearchText = '%' + cswSearchText.replace(/ /g, '%') + '%';
                
                filterSearch += '<PropertyIsLike wildCard="%" singleChar="_" escapeChar="\\">' +
                        '<PropertyName>AnyText</PropertyName>' +
                        '<Literal>' + cswSearchText + '</Literal>' +
                    '</PropertyIsLike>';
            }
            
            //Add filters
            if(filterSearch || filterBoundingBox) {
                var cswConstraint = '<csw:Constraint version="1.1.0">' +
                        '<ogc:Filter xmlns:xml="http://www.w3.org/XML/1998/namespace" xmlns:gml="http://www.opengis.net/gml" xmlns:ogc="http://www.opengis.net/ogc" xmlns="http://www.opengis.net/ogc">' +
                            '<ogc:And>' + filterSearch + filterBoundingBox + '</ogc:And>' +
                        '</ogc:Filter>' +
                    '</csw:Constraint>';
                
                cswData = cswData.replace('<csw:Constraint/>', cswConstraint);
            } else {
                cswData = cswData.replace('<csw:Constraint/>', '');
            }
        
        } else if (reqType == 'category') {
            //All spaces are replaced with .

            var filterSearch = new OpenLayers.Filter.Comparison({
                type: OpenLayers.Filter.Comparison.LIKE,
                property: "dc:subject",
                value: '*' + reqValue.replace(/ /g, '.') + '*'
            });
            
            var cswData = cswFormat.write({
                resultType: "results",
                startPosition: options.startPos,
                maxRecords: this.recordsPerPage,
                "Query": {
                    ElementSetName: {
                        value: "full"
                    },
                    Constraint: {
                        version: "1.1.0",
                        Filter: filterSearch
                     },
                    "SortBy": [{
                        "property": 'modified',
                        "order": "DESC"
                    }]  
                }
            });
        } else if (reqType == 'record') {
            //Set hash
            var hashObj = Giscuit.Util.getHash();
            hashObj.ac = 'csw';
            hashObj.csw = reqValue;
            Giscuit.Util.setHash(hashObj);            
            
            //
            for (var i = 0; i < this.records.length; i++) {
                if (this.records[i].identifier[0].value == reqValue) {
                    this.records = this.records.slice(i, i + 1);
                    
                    this.renderRecord(reqValue);
                    this.renderBounds(true);
                    return;
                }
            }
            
            var filterSearch = new OpenLayers.Filter.Comparison({
                type: OpenLayers.Filter.Comparison.EQUAL_TO,
                property: "dc:identifier",
                value: reqValue
            });
            
            var cswData = cswFormat.write({
                resultType: "results",
                startPosition: 1,
                maxRecords: 1,
                "Query": {
                    ElementSetName: {
                        value: "full"
                    },
                    Constraint: {
                        version: "1.1.0",
                        Filter: filterSearch
                     }
                }
            });
        }
        
        var reqOptions = {
            url: gt.config.httpProxyPath + encodeURIComponent(this.serverUrl),
            data: cswData,
            success : function(o) {
                var result = cswFormat.read(o.responseText);
                
                this.records = result.records;
                this.recordsTotal = result.SearchResults.numberOfRecordsMatched;
                                
                this.submitButton.set('disabled', false);
                
                if (this.records.length == 0) {
                    YAHOO.util.Event.purgeElement('gtCswContent', true);
                    YAHOO.util.Dom.get('gtCswContent').innerHTML = '<h2>' + gt.translate._('noRecordsFound') + '</h2>';
                } else if (reqType == 'latest') {
                    this.renderLatestRecords();
                } else if (reqType == 'search' || reqType == 'category') {
                    this.renderRecords();
                } else if (reqType == 'record') {
                    this.renderRecord(reqValue);
                }
                
                if (reqType != 'latest') {
                    this.renderBounds(true);
                }
            },
            failure: this.callbackFailure,
            scope: this
        };
        var request = OpenLayers.Request.POST(reqOptions);
    },
    
    renderRecords: function () {
        var self = this;
        
        //
        var render = function () {
            var html = '';
            
            for (var i = 0; i < self.records.length; i++) {
                html += '<li data-id="' + self.records[i].identifier[0].value + '">';
                
                //Title begin
                html += '<h2><a href="javascript:void(0)">' + self.records[i].title[0].value + '</a>';
                
                //Images
                var images = self.getImageUrls(self.records[i]); 
                if (images.length) {
                    for (var j=0; j < images.length; j++) {
                        html += '<span>' + 
                            '<img title="' + images[j].label + '" ' +
                            'data-img-url="' + images[j].url + '" ' +
                            'data-img-label="' + images[j].label + '" ' +
                            'src="' + gt.config.httpImagePath + '/camera_photo.png"></span>';
                    }
                }
                
                //Title end
                html += '</h2>';
                
                //Text
                if (typeof(self.records[i]['abstract']) != 'undefined' && self.records[i]['abstract'][0] != '') {
                    var descText = self.records[i]['abstract'][0];
                    descText = descText
                        .replace(/\r\n/g, "<br />")
                        .replace(/\n/g, "<br />");
                    
                    html += '<p>' + descText + '</p>';
                }
            }
            
            YAHOO.util.Event.purgeElement('gtCswRecordsList', true);
            YAHOO.util.Dom.get('gtCswRecordsList').innerHTML = html;
            
            //
            var showDetailed = function (event, matchedEl, container) {
                //Load records
                self.loadRecords({
                    name: 'record',
                    value: matchedEl.parentNode.parentNode.getAttribute('data-id')
                });
            }
            YAHOO.util.Event.delegate("gtCswRecordsList", "click", showDetailed, "a");

            //
            var showImage = function (event, matchedEl, container) {
                var label =  matchedEl.getAttribute('data-img-label');
                var url =  matchedEl.getAttribute('data-img-url');
                Giscuit.Util.photobox(label, url);
            }
            YAHOO.util.Event.delegate("gtCswRecordsList", "click", showImage, "img");
            
            //
            var req = YAHOO.lang.JSON.parse(
                YAHOO.lang.JSON.stringify(
                    self.history[self.history.length - 1]
                )
            );
            self.recordsPaginator.setPage(Math.floor(req.startPos / self.recordsPerPage) + 1, true);
        };
        
        //
        if(YAHOO.util.Dom.get('gtCswRecordsList')) {
            render();
            return;
        }
        
        //
        var html = '<ul id="gtCswRecordsList">';
        html += '</ul><div id="gtCswRecordsListPag"></div>';
        
        YAHOO.util.Event.purgeElement('gtCswContent', true);
        YAHOO.util.Dom.get('gtCswContent').innerHTML = html;
        
        //Paginator
        this.recordsPaginator = new YAHOO.widget.Paginator({
            alwaysVisible: false,
            rowsPerPage: this.recordsPerPage,
            totalRecords: this.recordsTotal,
            containers: "gtCswRecordsListPag",
            nextPageLinkLabel: gt.translate._('nextPage'),
            previousPageLinkLabel: gt.translate._('previousPage'),
            firstPageLinkLabel: gt.translate._('firstPage'),
            lastPageLinkLabel: gt.translate._('lastPage')
        });
        this.recordsPaginator.subscribe('changeRequest', function(state) {
            //
            this.recordsPaginator.setState(state);
            
            //
            var req = YAHOO.lang.JSON.parse(
                YAHOO.lang.JSON.stringify(
                    this.history[this.history.length - 1]
                )
            );
            req.startPos = (this.recordsPerPage * (state.page - 1)) + 1;
            
            //Load records
            this.loadRecords(req);
        }, null, this);
        this.recordsPaginator.render();
        
        //
        render();
    },
    
    renderRecord: function (id) {
        var self = this;
        var record = this.records[0];
                
        var html = '<div id="gtCswRecord"><h2 class="toggle on">' + record.title[0].value + '<span></span></h2><ul>';
        
        //Identifier
        html += '<li>' +
            '<div class="name">' + gt.translate._('metadataFileIdentifier') + ':</div>' +
            '<div class="value">' + record.identifier[0].value + '</div></li>';
            
        //Keywords
        if (typeof record.subject != 'undefined' && record.subject.length != 0) {
            var keywordsArr = [];
            for (var key in record.subject) {
                keywordsArr.push(record.subject[key].value);
            }
            html += '<li>' +
                '<div class="name">' + gt.translate._('keywords') + ':</div>' +
                '<div class="value">' + keywordsArr.join(', ') + '</div></li>';
        }
            
        //Description
        if (typeof record['abstract'] != 'undefined' && record['abstract'][0] != '') {
            var descText = record['abstract'][0];
            descText = descText
                .replace(/\r\n/g, "<br />")
                .replace(/\n/g, "<br />");
            
            html += '<li>' +
                '<div class="name">' + gt.translate._('description') + ':</div>' +
                '<div class="value">' + descText + '</div></li>';
        }
            
        //Modified date
        if (typeof record.modified != 'undefined' && record.modified[0] != '') {
            html += '<li>' +
                '<div class="name">' + gt.translate._('modifiedDate') + ':</div>' +
                '<div class="value">' + record.modified[0] + '</div></li>';
        }
            
        //Language
        if (typeof record.language != 'undefined' && record.language.length != 0) {
            html += '<li>' +
                '<div class="name">' + gt.translate._('language') + ':</div>' +
                '<div class="value">' + record.language[0].value + '</div></li>';
        }
        
        //Images
        var images = self.getImageUrls(record); 
        if (images.length) {
            html += '<li>' +
                '<div class="name">' + gt.translate._('images') + ':</div>' +
                '<div class="value">'; 
            
            for (var j=0; j < images.length; j++) {
                html += '<span>' + 
                    '<img style="cursor: pointer;" title="' + images[j].label + '" ' +
                    'data-img-url="' + images[j].url + '" ' +
                    'data-img-label="' + images[j].label + '" ' +
                    'src="' + gt.config.httpImagePath + '/camera_photo.png"></span>';
            }
            
            html += '</div></li>';
        }
        
        
        //Web address (URL)
        if (typeof record.URI != 'undefined' && record.URI.length != 0) {
            html += '<li>' +
                '<div class="name">' + gt.translate._('webAddress') + ':</div>' +
                '<div class="value uri"><ul>';
            
            //
            for (var key in record.URI) {
                //Ignore images
                if(record.URI[key].protocol && record.URI[key].protocol.toLowerCase().substring(0, 6) == 'image/') {
                    continue;
                }
                
                html += '<li>';
                
                //Wms
                if (record.URI[key].protocol && record.URI[key].protocol.toLowerCase().substring(0, 7) == 'ogc:wms') {
                    //
                    html += '<a href="javascript:gt.control.csw.addWmsLayer();">' + gt.translate._('addWmsLayerToMap') + '</a>';
                
                //
                } else {
                    var label = record.URI[key].description;
                    if(! label) {
                        label = record.URI[key].name;
                    }
                    html += '<a href="' + record.URI[key].value + '" target="_blank">' + label + '</a>';
                }
                html += '</li>';
            }
            
            html += '</ul></div></li>';
        }
            
        //Source
        if (typeof record.source != 'undefined' && record.source.length != 0) {
            html += '<li>' +
                '<div class="name">' + gt.translate._('source') + ':</div>' +
                '<div class="value">' + record.source[0].value + '</div></li>';
        }
            
        //Format
        if (typeof record.format != 'undefined' && record.format.length != 0) {
            var formatsArr = [];
            for (var key in record.format) {
                formatsArr.push(record.format[key].value);
            }
            html += '<li>' +
                '<div class="name">' + gt.translate._('format') + ':</div>' +
                '<div class="value">' + formatsArr.join(', ') + '</div></li>';
        }
        
        //Link for XML
        if (this.brand == 'gn') {
            var xmlUrl = this.serverUrl.slice(0, -4) + '/iso19139.xml?uuid=' + id;
            html += '<li><div class="name">' + gt.translate._('downloadAsXML') + ':</div>' +
                '<div class="value"><a target="_blank" href="' + xmlUrl + '">' + xmlUrl + '</a></div></li>';
        }
            
        //License
        if (typeof record.rights != 'undefined' && record.rights.length != 0) {
            var rightsArr = [];
            for (var key in record.rights) {
                rightsArr.push(record.rights[key].value);
            }
            html += '<li>' +
                '<div class="name">' + gt.translate._('license') + ':</div>' +
                '<div class="value">' + rightsArr.join(', ') + '</div></li>';
        }
            
        html += '</ul>';
            
        //    

        if (this.brand) {
            html += '<h2 class="toggle off extended">' + gt.translate._('seeMore') + '<span></span></h2><div id="gtCswRecordExtended" display="none;"></div>';
        }
        
        html += '</div>';
        
        YAHOO.util.Event.purgeElement('gtCswContent', true);
        YAHOO.util.Dom.get('gtCswContent').innerHTML = html;
        
        //Toggle events
        YAHOO.util.Event.delegate("gtCswRecord", "click", function(evt, matchedEl, container) {
            var dom = YAHOO.util.Dom;
            
            //
            if(dom.hasClass(matchedEl, 'extended') && ! matchedEl.nextSibling.innerHTML) {
                matchedEl.nextSibling.innerHTML = self.getLoadingImage();
                //TODO: Load extended content
                self.loadRecordExtendedGn(id);
            }        
            
            //
            var status = 'on';
            var display = 'block';
            if(dom.hasClass(matchedEl, 'on')) {
                status = 'off';
                display = 'none';
            } 
            
            //Reset
            var nodes = YAHOO.util.Selector.query('#gtCswRecord > h2');
            for(var i = 0; i < nodes.length; i++) {
                dom.removeClass(nodes[i], 'on');
                dom.addClass(nodes[i], 'off');
                nodes[i].nextSibling.style.display = 'none';
            }

            //
            dom.addClass(matchedEl, status);
            matchedEl.nextSibling.style.display = display;
                        
        }, "h2");
        
        //
        var showImage = function (event, matchedEl, container) {
            var label =  matchedEl.getAttribute('data-img-label');
            var url =  matchedEl.getAttribute('data-img-url');
            Giscuit.Util.photobox(label, url);
        }
        YAHOO.util.Event.delegate("gtCswRecord", "click", showImage, "img");
    },
    
    renderLatestRecords: function () {
        var self = this;
        var html = '<h2>' + gt.translate._('recentlyAdded') + '</h2><ul id="gtCswLatestRecords">';

        for (var i = 0; i < this.records.length; i++) {
            html += '<li data-id="' + this.records[i].identifier[0].value + '"><a href="javascript:void(0)">' + this.records[i].title[0].value + '</a></li>';
        }
        
        html += '</ul>';
        
        YAHOO.util.Event.purgeElement('gtCatalogLatest', true);
        YAHOO.util.Dom.get('gtCatalogLatest').innerHTML = html;
        
        var showDetailed = function (event, matchedEl, container) {
            self.loadRecords({
                name: 'record', 
                value: matchedEl.parentNode.getAttribute('data-id')
            });
        }
        YAHOO.util.Event.delegate("gtCswLatestRecords", "click", showDetailed, "a"); 
    },
    
    getImageUrls: function(record) {
        var urls = [];
        
        //Web address (URL)
        if (typeof record.URI != 'undefined' && record.URI.length != 0) {
            for (var key in record.URI) {
                if(record.URI[key].protocol && record.URI[key].protocol.toLowerCase().substring(0, 6) == 'image/') {
                    var url = record.URI[key].value;
                    
                    var label = record.URI[key].description;
                    if(! label) {
                        label = record.URI[key].name;
                    }
                    
                    //Gn
                    if (this.brand == 'gn') { 
                        if(url.substring(0, 13) == 'resources.get') {
                            url = this.serverUrl.slice(0, -4) + '/' + url;
                        }

                        if(label == 'thumbnail') {
                            url = url.replace('_s.png', '.png');
                            url = url.replace('_s.jpg', '.jpg');
                            url = url.replace('_s.gif', '.gif');
                        }
                    }
                    
                    urls.push({
                        'label': label,
                        'url': url
                    });
                }
            }
        }
                        
        return urls;
    },
    
    renderBounds: function(zoom) {
        var mergedBounds = new OpenLayers.Bounds();
        
        gt.layer.vector.destroyFeatures(this.bounds);
        this.bounds = [];
        
        for(var i=0; i < this.records.length; i++) {
            if(typeof(this.records[i].bounds) == 'undefined') {
                continue;
            }
            
            var bounds = this.records[i].bounds;
            var projection = new OpenLayers.Projection(this.records[i].projection);
            bounds.transform(projection, gt.map.projection);
            
            mergedBounds.extend(bounds);
            
            var geometry = bounds.toGeometry();
            var feature = new OpenLayers.Feature.Vector(geometry);
            feature.attributes.id = this.records[i].identifier[0].value;
            feature.attributes.title = this.records[i].title[0].value;
            
            feature.styleMap = OpenLayers.Util.applyDefaults({}, gt.layer.vector.styleMap);
            
            this.bounds.push(feature);
        }
        
        gt.layer.vector.addFeatures(this.bounds);
        
        if(zoom && mergedBounds.toString() != new OpenLayers.Bounds().toString()) {
            gt.map.zoomToExtent(mergedBounds);
        }
    },
    
    loadRecordExtendedGn: function(id) {
        var url = gt.config.httpProxyPath + 
            encodeURIComponent(this.serverUrl.slice(0, -4) + '/metadata.show.embedded?uuid=' + id);
        
        var callback = {
                success: this.renderRecordExtendedGn,
                timeout: this.callbackTimeout,
                failure: this.callbackFailure,
                scope: this
            };

        var request = YAHOO.util.Connect.asyncRequest('GET', url, callback);
    },
    
    renderRecordExtendedGn: function(data) {
        var html = data.responseText.toString();
        
        //Remove all cursor:help; matches
        html = html.replace(/cursor:help;/gi, '');
        
        //Create dom node
        var div = document.createElement('div');
        div.innerHTML = html;
        
        //Get top element
        var topEl = YAHOO.util.Dom.getElementsByClassName('md', 'table', div);
        if(! topEl.length) {
            return false;
        } else {
            topEl = topEl[0];
        }
        
        //Hide first tr
        topEl.children[0].children[0].style.display = 'none';
        
        //Hide extent
        var nodes = YAHOO.util.Selector.query('legend > span', topEl);
        for(var i = 0; i < nodes.length; i++) {
            if(nodes[i].id.search(/BoundingBox/i) > 0) {
                tmpEl = nodes[i].parentNode;
                while(tmpEl.className != 'padded-content') {
                    tmpEl = tmpEl.parentNode;
                }
                tmpEl = tmpEl.parentNode;
                while(tmpEl.className != 'padded-content') {
                    tmpEl = tmpEl.parentNode;
                }
                tmpEl.style.display = 'none';
            }
        }
        
        //Hide google earth links
        var nodes = YAHOO.util.Selector.query('a', topEl);
        for(var i = 0; i < nodes.length; i++) {
            if(nodes[i].href.search(/google\.kml/i) > 0) {
                nodes[i].parentNode.parentNode.style.display = 'none';
            }
        }

        //
        var extendedDiv = YAHOO.util.Dom.get('gtCswRecordExtended');
        extendedDiv.innerHTML = '';
        extendedDiv.appendChild(topEl);
    },
    
    addWmsLayer: function() {
        var layerInfo = this.records[0];
        for (var i = 0; i < layerInfo.URI.length; i++) {
            if (layerInfo.URI[i].protocol.toLowerCase().substring(0, 7) == 'ogc:wms') {
                var url = layerInfo.URI[i].value.replace(/[^a-zA-Z0-9]/gi,'');
                
                //Check if layer already exists
                for (var key in gt.layer) {
                    if (key == url + '_' + layerInfo.URI[i].name) {
                        return;
                    }
                }
                
                var layer = new OpenLayers.Layer.WMS(url + '_' + layerInfo.URI[i].name,
                    layerInfo.URI[i].value,
                    {layers: layerInfo.URI[i].name, transparent: "true"},
                    {singleTile: true, ratio: 1.1} 
                );
                gt.control.layers.addLayer(layer, {name: layerInfo.URI[i].description}, 'overlay');
            }
        }
    },
    
    CLASS_NAME: "Giscuit.Control.Csw"
});

OpenLayers.Format.CSWGetRecords=function(a){var a=OpenLayers.Util.applyDefaults(a,OpenLayers.Format.CSWGetRecords.DEFAULTS),b=OpenLayers.Format.CSWGetRecords["v"+a.version.replace(/\./g,"_")];if(!b)throw"Unsupported CSWGetRecords version: "+a.version;return new b(a)};OpenLayers.Format.CSWGetRecords.DEFAULTS={version:"2.0.2"};OpenLayers.Format.OWSCommon=OpenLayers.Class(OpenLayers.Format.XML.VersionedOGC,{defaultVersion:"1.0.0",getVersion:function(a){var b=this.version;b||((a=a.getAttribute("xmlns:ows"))&&"1.1"===a.substring(a.lastIndexOf("/")+1)&&(b="1.1.0"),b||(b=this.defaultVersion));return b},CLASS_NAME:"OpenLayers.Format.OWSCommon"});OpenLayers.Format.OWSCommon.v1=OpenLayers.Class(OpenLayers.Format.XML,{regExes:{trimSpace:/^\s*|\s*$/g,removeSpace:/\s*/g,splitSpace:/\s+/,trimComma:/\s*,\s*/g},read:function(a,b){OpenLayers.Util.applyDefaults(b,this.options);var c={};this.readChildNodes(a,c);return c},readers:{ows:{Exception:function(a,b){var c={code:a.getAttribute("exceptionCode"),locator:a.getAttribute("locator"),texts:[]};b.exceptions.push(c);this.readChildNodes(a,c)},ExceptionText:function(a,b){var c=this.getChildValue(a);b.texts.push(c)},
    ServiceIdentification:function(a,b){b.serviceIdentification={};this.readChildNodes(a,b.serviceIdentification)},Title:function(a,b){b.title=this.getChildValue(a)},Abstract:function(a,b){b["abstract"]=this.getChildValue(a)},Keywords:function(a,b){b.keywords={};this.readChildNodes(a,b.keywords)},Keyword:function(a,b){b[this.getChildValue(a)]=!0},ServiceType:function(a,b){b.serviceType={codeSpace:a.getAttribute("codeSpace"),value:this.getChildValue(a)}},ServiceTypeVersion:function(a,b){b.serviceTypeVersion=
    this.getChildValue(a)},Fees:function(a,b){b.fees=this.getChildValue(a)},AccessConstraints:function(a,b){b.accessConstraints=this.getChildValue(a)},ServiceProvider:function(a,b){b.serviceProvider={};this.readChildNodes(a,b.serviceProvider)},ProviderName:function(a,b){b.providerName=this.getChildValue(a)},ProviderSite:function(a,b){b.providerSite=this.getAttributeNS(a,this.namespaces.xlink,"href")},ServiceContact:function(a,b){b.serviceContact={};this.readChildNodes(a,b.serviceContact)},IndividualName:function(a,
    b){b.individualName=this.getChildValue(a)},PositionName:function(a,b){b.positionName=this.getChildValue(a)},ContactInfo:function(a,b){b.contactInfo={};this.readChildNodes(a,b.contactInfo)},Phone:function(a,b){b.phone={};this.readChildNodes(a,b.phone)},Voice:function(a,b){b.voice=this.getChildValue(a)},Address:function(a,b){b.address={};this.readChildNodes(a,b.address)},DeliveryPoint:function(a,b){b.deliveryPoint=this.getChildValue(a)},City:function(a,b){b.city=this.getChildValue(a)},AdministrativeArea:function(a,
    b){b.administrativeArea=this.getChildValue(a)},PostalCode:function(a,b){b.postalCode=this.getChildValue(a)},Country:function(a,b){b.country=this.getChildValue(a)},ElectronicMailAddress:function(a,b){b.electronicMailAddress=this.getChildValue(a)},Role:function(a,b){b.role=this.getChildValue(a)},OperationsMetadata:function(a,b){b.operationsMetadata={};this.readChildNodes(a,b.operationsMetadata)},Operation:function(a,b){var c=a.getAttribute("name");b[c]={};this.readChildNodes(a,b[c])},DCP:function(a,
    b){b.dcp={};this.readChildNodes(a,b.dcp)},HTTP:function(a,b){b.http={};this.readChildNodes(a,b.http)},Get:function(a,b){b.get||(b.get=[]);var c={url:this.getAttributeNS(a,this.namespaces.xlink,"href")};this.readChildNodes(a,c);b.get.push(c)},Post:function(a,b){b.post||(b.post=[]);var c={url:this.getAttributeNS(a,this.namespaces.xlink,"href")};this.readChildNodes(a,c);b.post.push(c)},Parameter:function(a,b){b.parameters||(b.parameters={});var c=a.getAttribute("name");b.parameters[c]={};this.readChildNodes(a,
    b.parameters[c])},Constraint:function(a,b){b.constraints||(b.constraints={});var c=a.getAttribute("name");b.constraints[c]={};this.readChildNodes(a,b.constraints[c])},Value:function(a,b){b[this.getChildValue(a)]=!0},OutputFormat:function(a,b){b.formats.push({value:this.getChildValue(a)});this.readChildNodes(a,b)},WGS84BoundingBox:function(a,b){var c={};c.crs=a.getAttribute("crs");b.BoundingBox?b.BoundingBox.push(c):(b.projection=c.crs,c=b);this.readChildNodes(a,c)},BoundingBox:function(a,b){this.readers.ows.WGS84BoundingBox.apply(this,
    [a,b])},LowerCorner:function(a,b){var c=this.getChildValue(a).replace(this.regExes.trimSpace,""),c=c.replace(this.regExes.trimComma,","),c=c.split(this.regExes.splitSpace);b.left=c[0];b.bottom=c[1]},UpperCorner:function(a,b){var c=this.getChildValue(a).replace(this.regExes.trimSpace,""),c=c.replace(this.regExes.trimComma,","),c=c.split(this.regExes.splitSpace);b.right=c[0];b.top=c[1];b.bounds=new OpenLayers.Bounds(b.left,b.bottom,b.right,b.top);delete b.left;delete b.bottom;delete b.right;delete b.top},
    Language:function(a,b){b.language=this.getChildValue(a)}}},writers:{ows:{BoundingBox:function(a,b){var c=this.createElementNSPlus(b||"ows:BoundingBox",{attributes:{crs:a.projection}});this.writeNode("ows:LowerCorner",a,c);this.writeNode("ows:UpperCorner",a,c);return c},LowerCorner:function(a){return this.createElementNSPlus("ows:LowerCorner",{value:a.bounds.left+" "+a.bounds.bottom})},UpperCorner:function(a){return this.createElementNSPlus("ows:UpperCorner",{value:a.bounds.right+" "+a.bounds.top})},
    Identifier:function(a){return this.createElementNSPlus("ows:Identifier",{value:a})},Title:function(a){return this.createElementNSPlus("ows:Title",{value:a})},Abstract:function(a){return this.createElementNSPlus("ows:Abstract",{value:a})},OutputFormat:function(a){return this.createElementNSPlus("ows:OutputFormat",{value:a})}}},CLASS_NAME:"OpenLayers.Format.OWSCommon.v1"});OpenLayers.Format.OWSCommon.v1_0_0=OpenLayers.Class(OpenLayers.Format.OWSCommon.v1,{namespaces:{ows:"http://www.opengis.net/ows",xlink:"http://www.w3.org/1999/xlink"},readers:{ows:OpenLayers.Util.applyDefaults({ExceptionReport:function(a,b){b.success=!1;b.exceptionReport={version:a.getAttribute("version"),language:a.getAttribute("language"),exceptions:[]};this.readChildNodes(a,b.exceptionReport)}},OpenLayers.Format.OWSCommon.v1.prototype.readers.ows)},writers:{ows:OpenLayers.Format.OWSCommon.v1.prototype.writers.ows},
    CLASS_NAME:"OpenLayers.Format.OWSCommon.v1_0_0"});OpenLayers.Format.OWSCommon.v1_1_0=OpenLayers.Class(OpenLayers.Format.OWSCommon.v1,{namespaces:{ows:"http://www.opengis.net/ows/1.1",xlink:"http://www.w3.org/1999/xlink"},readers:{ows:OpenLayers.Util.applyDefaults({ExceptionReport:function(a,b){b.exceptionReport={version:a.getAttribute("version"),language:a.getAttribute("xml:lang"),exceptions:[]};this.readChildNodes(a,b.exceptionReport)},AllowedValues:function(a,b){b.allowedValues={};this.readChildNodes(a,b.allowedValues)},AnyValue:function(a,b){b.anyValue=
    !0},DataType:function(a,b){b.dataType=this.getChildValue(a)},Range:function(a,b){b.range={};this.readChildNodes(a,b.range)},MinimumValue:function(a,b){b.minValue=this.getChildValue(a)},MaximumValue:function(a,b){b.maxValue=this.getChildValue(a)},Identifier:function(a,b){b.identifier=this.getChildValue(a)},SupportedCRS:function(a,b){b.supportedCRS=this.getChildValue(a)}},OpenLayers.Format.OWSCommon.v1.prototype.readers.ows)},writers:{ows:OpenLayers.Util.applyDefaults({Range:function(a){var b=this.createElementNSPlus("ows:Range",
    {attributes:{"ows:rangeClosure":a.closure}});this.writeNode("ows:MinimumValue",a.minValue,b);this.writeNode("ows:MaximumValue",a.maxValue,b);return b},MinimumValue:function(a){return this.createElementNSPlus("ows:MinimumValue",{value:a})},MaximumValue:function(a){return this.createElementNSPlus("ows:MaximumValue",{value:a})},Value:function(a){return this.createElementNSPlus("ows:Value",{value:a})}},OpenLayers.Format.OWSCommon.v1.prototype.writers.ows)},CLASS_NAME:"OpenLayers.Format.OWSCommon.v1_1_0"});OpenLayers.Format.CSWGetRecords.v2_0_2=OpenLayers.Class(OpenLayers.Format.XML,{namespaces:{csw:"http://www.opengis.net/cat/csw/2.0.2",dc:"http://purl.org/dc/elements/1.1/",dct:"http://purl.org/dc/terms/",gmd:"http://www.isotc211.org/2005/gmd",geonet:"http://www.fao.org/geonetwork",ogc:"http://www.opengis.net/ogc",ows:"http://www.opengis.net/ows",xlink:"http://www.w3.org/1999/xlink",xsi:"http://www.w3.org/2001/XMLSchema-instance"},defaultPrefix:"csw",version:"2.0.2",schemaLocation:"http://www.opengis.net/cat/csw/2.0.2 http://schemas.opengis.net/csw/2.0.2/CSW-discovery.xsd",
    requestId:null,resultType:null,outputFormat:null,outputSchema:null,startPosition:null,maxRecords:null,DistributedSearch:null,ResponseHandler:null,Query:null,regExes:{trimSpace:/^\s*|\s*$/g,removeSpace:/\s*/g,splitSpace:/\s+/,trimComma:/\s*,\s*/g},initialize:function(a){OpenLayers.Format.XML.prototype.initialize.apply(this,[a])},read:function(a){"string"==typeof a&&(a=OpenLayers.Format.XML.prototype.read.apply(this,[a]));a&&9==a.nodeType&&(a=a.documentElement);var b={};this.readNode(a,b);return b},
    readers:{csw:{GetRecordsResponse:function(a,b){b.records=[];this.readChildNodes(a,b);var c=this.getAttributeNS(a,"","version");""!=c&&(b.version=c)},RequestId:function(a,b){b.RequestId=this.getChildValue(a)},SearchStatus:function(a,b){b.SearchStatus={};var c=this.getAttributeNS(a,"","timestamp");""!=c&&(b.SearchStatus.timestamp=c)},SearchResults:function(a,b){this.readChildNodes(a,b);for(var c=a.attributes,e={},d=0,f=c.length;d<f;++d)e[c[d].name]="numberOfRecordsMatched"==c[d].name||"numberOfRecordsReturned"==
    c[d].name||"nextRecord"==c[d].name?parseInt(c[d].nodeValue):c[d].nodeValue;b.SearchResults=e},SummaryRecord:function(a,b){var c={type:"SummaryRecord"};this.readChildNodes(a,c);b.records.push(c)},BriefRecord:function(a,b){var c={type:"BriefRecord"};this.readChildNodes(a,c);b.records.push(c)},DCMIRecord:function(a,b){var c={type:"DCMIRecord"};this.readChildNodes(a,c);b.records.push(c)},Record:function(a,b){var c={type:"Record"};this.readChildNodes(a,c);b.records.push(c)},"*":function(a,b){var c=a.localName||
    a.nodeName.split(":").pop();b[c]=this.getChildValue(a)}},geonet:{info:function(a,b){var c={};this.readChildNodes(a,c);b.gninfo=c}},dc:{"*":function(a,b){var c=a.localName||a.nodeName.split(":").pop();OpenLayers.Util.isArray(b[c])||(b[c]=[]);for(var e={},d=a.attributes,f=0,g=d.length;f<g;++f)e[d[f].name]=d[f].nodeValue;e.value=this.getChildValue(a);""!=e.value&&b[c].push(e)}},dct:{"*":function(a,b){var c=a.localName||a.nodeName.split(":").pop();OpenLayers.Util.isArray(b[c])||(b[c]=[]);b[c].push(this.getChildValue(a))}},
    ows:OpenLayers.Util.applyDefaults({BoundingBox:function(a,b){b.bounds&&(b.BoundingBox=[{crs:b.projection,value:[b.bounds.left,b.bounds.bottom,b.bounds.right,b.bounds.top]}],delete b.projection,delete b.bounds);OpenLayers.Format.OWSCommon.v1_0_0.prototype.readers.ows.BoundingBox.apply(this,arguments)}},OpenLayers.Format.OWSCommon.v1_0_0.prototype.readers.ows)},write:function(a){a=this.writeNode("csw:GetRecords",a);a.setAttribute("xmlns:gmd",this.namespaces.gmd);return OpenLayers.Format.XML.prototype.write.apply(this,
    [a])},writers:{csw:{GetRecords:function(a){a||(a={});var b=this.createElementNSPlus("csw:GetRecords",{attributes:{service:"CSW",version:this.version,requestId:a.requestId||this.requestId,resultType:a.resultType||this.resultType,outputFormat:a.outputFormat||this.outputFormat,outputSchema:a.outputSchema||this.outputSchema,startPosition:a.startPosition||this.startPosition,maxRecords:a.maxRecords||this.maxRecords}});if(a.DistributedSearch||this.DistributedSearch)this.writeNode("csw:DistributedSearch",
    a.DistributedSearch||this.DistributedSearch,b);var c=a.ResponseHandler||this.ResponseHandler;if(OpenLayers.Util.isArray(c)&&0<c.length)for(var e=0,d=c.length;e<d;e++)this.writeNode("csw:ResponseHandler",c[e],b);this.writeNode("Query",a.Query||this.Query,b);return b},DistributedSearch:function(a){return this.createElementNSPlus("csw:DistributedSearch",{attributes:{hopCount:a.hopCount}})},ResponseHandler:function(a){return this.createElementNSPlus("csw:ResponseHandler",{value:a.value})},Query:function(a){a||
    (a={});var b=this.createElementNSPlus("csw:Query",{attributes:{typeNames:a.typeNames||"csw:Record"}}),c=a.ElementName;if(OpenLayers.Util.isArray(c)&&0<c.length)for(var e=0,d=c.length;e<d;e++)this.writeNode("csw:ElementName",c[e],b);else this.writeNode("csw:ElementSetName",a.ElementSetName||{value:"summary"},b);a.Constraint&&this.writeNode("csw:Constraint",a.Constraint,b);a.SortBy&&this.writeNode("ogc:SortBy",a.SortBy,b);return b},ElementName:function(a){return this.createElementNSPlus("csw:ElementName",
    {value:a.value})},ElementSetName:function(a){return this.createElementNSPlus("csw:ElementSetName",{attributes:{typeNames:a.typeNames},value:a.value})},Constraint:function(a){var b=this.createElementNSPlus("csw:Constraint",{attributes:{version:a.version}});if(a.Filter){var c=new OpenLayers.Format.Filter({version:a.version});b.appendChild(c.write(a.Filter))}else a.CqlText&&(a=this.createElementNSPlus("CqlText",{value:a.CqlText.value}),b.appendChild(a));return b}},ogc:OpenLayers.Format.Filter.v1_1_0.prototype.writers.ogc},
    CLASS_NAME:"OpenLayers.Format.CSWGetRecords.v2_0_2"});