/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this package in the file LICENSE.txt.
 *
 * @version    $Id: Print.js 2744 2012-06-12 07:27:23Z pavel.iacovlev $
 * @copyright  Copyright (c) 2012 VEC
 */
Giscuit.Map.prototype.gtEventListeners.push({
    'draw': function() {
        gt.control.print = new Giscuit.Control.Print();
    }
});

/**
 * Class: Giscuit.Control.Print
 * 
 *  Inherits from:
 *   - <Giscuit.Control>
 */
Giscuit.Control.Print = OpenLayers.Class(Giscuit.Control, {
    
    button: null,
    
    initialize: function (options) {
        Giscuit.Control.prototype.initialize.apply(this, [options]);
        
        this.button = new YAHOO.widget.Button({ 
            label: gt.map.getControlIcon(15), 
            id: "gtControlPrint", 
            onclick: {fn: function() {
                gt.control.print.activate();
            }},
            title: gt.translate._('print'), 
            container: "gtMapControls" 
        });

    },
    
    activate: function() {
        var activated = Giscuit.Control.prototype.activate.call(this);
    
        var hashString = Giscuit.Util.setHash(Giscuit.Util.getHash());
       
        window.open(gt.config.httpPath + '/map/index/type/print#' + hashString, 
            '', 
            'width=750,height=900,menubar=no,status=no,location=no,toolbar=no,scrollbars=yes'
        );
        
        return activated;
    },
    
    CLASS_NAME: "Giscuit.Control.Print"
});