/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this package in the file LICENSE.txt.
 *
 * @version    $Id: Coords.js 2744 2012-06-12 07:27:23Z pavel.iacovlev $
 * @copyright  Copyright (c) 2012 VEC
 */
Giscuit.Mobile.Map.prototype.gtEventListeners.push({
    'draw': function() {
        gt.control.coords = new Giscuit.Mobile.Control.Coords();
    }
});

/**
 * Class: Giscuit.Mobile.Control.Coords
 * 
 *  Inherits from:
 *   - <Giscuit.Control.Coords>
 */
Giscuit.Mobile.Control.Coords = OpenLayers.Class(Giscuit.Control.Coords, {
    
    initialize: function (options) {
        
        if (! gt.pluginParams.coordsPluginIsAllowed) {
            return;
        }
        
        //
        $("#gtMapControls").append('<div>'
            + '<div class="ui-bar ui-bar-c" id="gtCoordsButton">'
            + '<div class="gtMapControlsElImage" style="background-image: url(\'' + gt.config.httpImagePath + '/coords_mobile.png\');"></div>'
            + '<div class="gtMapControlsElText">' + gt.translate._('coordsShort') + '</div>'
            + '</div></div>');
        
        // 
        $("#gtCoordsButton").on(gt.config.clickEvt, this, function(evt) {
            //
            evt.stopImmediatePropagation();
            
            //Hide map controls
            gt.init.layout.hideMapControls();
            
            $.mobile.showPageLoadingMsg();
            
            //
            if(! $('#gtCoords').length) {
                evt.data.create();
            } else {
                if (! $('#gtCoordsTypeSelectText').hasClass('ui-btn-active')) {
                    $('#gtCoordsTypeSelectText').addClass('ui-btn-active');
                    
                    $('#gtCoordsImportContentGpx').css('display', 'none');
                    $('#gtCoordsImportContentKml').css('display', 'none');
                    $('#gtCoordsImportContentCsv').css('display', 'none');
                    $('#gtCoordsImportContentText').css('display', 'block');
                    $('#gtCoordsImportContentProj').css('display', 'block');
                }
            }
            
            $.mobile.changePage($('#gtCoords'), {
                'changeHash': true
            });
            
            $.mobile.hidePageLoadingMsg();
            
            return false;
        });
        
        Giscuit.Control.prototype.initialize.apply(this, [options]);
    },
    
    create: function() {
        
        //Add css
        
        //Add html
        //var projectionLink = gt.map.projection.toString().replace(':', '::');
        //var projectionName = gt.translate._('mapProjection').replace('%1$s', projectionLink).replace(/%2\$s/g, gt.map.projection);
        
        var html = '<div data-role="page" id="gtCoords" data-dom-cache="true" data-url="gtCoords">' +
            '<div data-role="header">' +
                '<h1>' + gt.translate._('coords') + '</h1>' +
                '<a href="#gtMap" data-icon="map" data-direction="reverse" class="ui-btn-right jqm-home">' +
                    gt.translate._('map') + 
                '</a>' + 
            '</div>' +
         
            '<div data-role="content">' + 
                
                '<div data-role="navbar" data-grid="c">' +
                    '<ul id="gtCoordsTypeSelect">' +
                        '<li><a id="gtCoordsTypeSelectText" href="" class="ui-btn-active">' + gt.translate._('text') + '</a></li>' +
                        '<li><a id="gtCoordsTypeSelectGpx" href="">' + gt.translate._('gpx') + '</a></li>' +
                        '<li><a id="gtCoordsTypeSelectKml" href="">' + gt.translate._('kml') + '</a></li>' +
                        '<li><a id="gtCoordsTypeSelectCsv" href="">' + gt.translate._('csv') + '</a></li>' +
                    '</ul>' +
                '</div>' +
                
                '<div id="gtCoordsImportContent">' +
                    '<div id="gtCoordsImportContentText">' +
                        '<form id="gtCoordsImportTextForm"><dl class="zend_form">' +
                        '<dt><label for="gtCoordsImportX">' + gt.translate._('xCoord') + '</label></dt>' +
                        '<dd><input id="gtCoordsImportX" type="text"></dd>' +
                        '<dt><label for="gtCoordsImportY">' + gt.translate._('yCoord') + '</label></dt>' +
                        '<dd><input id="gtCoordsImportY" type="text"></dd>' +
                        '<dt><label for="gtCoordsImportLabel">' + gt.translate._('label') + '</label></dt>' +
                        '<dd><input id="gtCoordsImportLabel" type="text"></dd>' +
                        '</form>' +
                    '</div>' +
                    '<div id="gtCoordsImportContentGpx" style="display: none;">' +
                        '<form id="gtCoordsImportGpxForm"><dl class="zend_form">' +
                        '<dt><label for="gtCoordsImportGpxFile">' + gt.translate._('selectFile') + '</label></dt>' +
                        '<dd><input id="gtCoordsImportGpxFile" type="file" name="file"></dd>' +
                        '</form>' +
                    '</div>' +
                    '<div id="gtCoordsImportContentKml" style="display: none;">' +
                        '<form id="gtCoordsImportKmlForm"><dl class="zend_form">' +
                        '<dt><label for="gtCoordsImportKmlFile">' + gt.translate._('selectFile') + '</label></dt>' +
                        '<dd><input id="gtCoordsImportKmlFile" type="file" name="file"></dd>' +
                        '</form>' +
                    '</div>' +
                    '<div id="gtCoordsImportContentCsv" style="display: none;">' +
                        '<form id="gtCoordsImportCsvForm"><dl class="zend_form">' +
                        '<dt><label for="gtCoordsImportCsvFile">' + gt.translate._('selectFile') + '</label></dt>' +
                        '<dd><input id="gtCoordsImportCsvFile" type="file" name="file"></dd>' +
                        '</form>' +
                        '<div style="color: #CC1100;">' + gt.translate._('csvFormatWarning') + '</div><br>' +
                    '</div>' +
                    '<div id="gtCoordsImportContentProj">' +
                        '<form id="gtCoordsImportProjForm"><dl class="zend_form">' +
                        '<dt><label>' + gt.translate._('coordinatesIn') + ':</label></dt>' +
                        '<dd><fieldset data-role="controlgroup">' +
                        '<input name="gtCoordsProjType" id="gtCoordsProjTypeWgs" value="EPSG:4326" checked="checked" type="radio">' +
                        '<label for="gtCoordsProjTypeWgs">' + gt.translate._('wgs') + '</label>' +
                        '<input name="gtCoordsProjType" id="gtCoordsProjTypeMapProj" value="mapProj" type="radio">' +
                        '<label for="gtCoordsProjTypeMapProj">' + gt.map.projection + '</label>' +
                        '</fieldset></dd>' +
                        '</form>' +
                    '</div>' +
                '</div>' + 
                
                '<div data-role="controlgroup">' +
                    '<a href="javascript:void(0);" id="gtCoordsImportButton" data-role="button">' + gt.translate._('import') + '</a>' +
                    '<a href="javascript:void(0);" id="gtCoordsClearButton" data-role="button">' + gt.translate._('clear') + '</a>' +
                '</div>' +
                
            '</div>' + 
            
        '</div>';
    
        $.mobile.pageContainer.append(html);
        $('#gtCoords').page();
        
        //Layer
        this.addLayer();
        
        //Events
        $("#gtCoordsTypeSelect").children().on(gt.config.clickEvt, this, function(evt) {
            $('#gtCoordsImportContentText').css('display', 'none');
            $('#gtCoordsImportContentGpx').css('display', 'none');
            $('#gtCoordsImportContentKml').css('display', 'none');
            $('#gtCoordsImportContentCsv').css('display', 'none');
            $('#gtCoordsImportContentProj').css('display', 'none');
            
            if ($(this).children().first().attr('id') == 'gtCoordsTypeSelectText') {
                $('#gtCoordsImportContentText').css('display', 'block');
                $('#gtCoordsImportContentProj').css('display', 'block');
            } else if ($(this).children().first().attr('id') == 'gtCoordsTypeSelectGpx') {
                $('#gtCoordsImportContentGpx').css('display', 'block');
            } else if ($(this).children().first().attr('id') == 'gtCoordsTypeSelectKml') {
                $('#gtCoordsImportContentKml').css('display', 'block');
            } else if ($(this).children().first().attr('id') == 'gtCoordsTypeSelectCsv') {
                $('#gtCoordsImportContentCsv').css('display', 'block');
                $('#gtCoordsImportContentProj').css('display', 'block');
            }
        });
        
        $("#gtCoordsImportButton").on(gt.config.clickEvt, this, function(evt) {
            $.mobile.showPageLoadingMsg();

            if ($('#gtCoordsTypeSelectText').hasClass('ui-btn-active')) {
                evt.data.addFromText();
            } else if ($('#gtCoordsTypeSelectGpx').hasClass('ui-btn-active')) {
                evt.data.addFromGpx();
            } else if ($('#gtCoordsTypeSelectKml').hasClass('ui-btn-active')) {
                evt.data.addFromKml();
            } else if ($('#gtCoordsTypeSelectCsv').hasClass('ui-btn-active')) {
                evt.data.addFromCsv();
            }
            
            $.mobile.changePage($('#gtMap'));
            
            $.mobile.hidePageLoadingMsg();
            
            return false;
        });
        
        $("#gtCoordsClearButton").on(gt.config.clickEvt, this, function(evt) {
            evt.data.layer.removeAllFeatures();
            
            return false;
        });
        
    },
    
    uploadFile: function(fileElement, format) {
        var self = this;
        $('#gtCoordsImportButton').buttonMarkup("disable");
        var form = $(fileElement).closest('form');

        $(form).ajaxSubmit({
            'type': 'POST',
            'url': gt.config.httpToolPath + "/coords",
            'success': function(data, status, object) {
                $('#gtCoordsImportButton').buttonMarkup('enable');

                if (object.responseXML && format.CLASS_NAME != "OpenLayers.Format.CSW") {
                    var fileContents = object.responseXML;
                } else {
                    var fileContents = object.responseText;
                }
                
                if (typeof(fileContents) == 'string' && fileContents.substring(0,5) == '<pre>') {
                    fileContents = fileContents.substring(5);
                    fileContents = fileContents.substring(0, fileContents.length -6);
                }
                
                var features = format.read(fileContents);
                
                if (features && features.length) {
                    var bounds = new OpenLayers.Bounds();
                    for(var i = 0; i < features.length; ++i) {
                        bounds.extend(features[i].geometry.getBounds());
                    }
                    
                    self.layer.addFeatures(features);
                    gt.map.zoomToExtent(bounds);
                } else {
                    debug.warn('No features loaded');
                }
            },
            'error': Giscuit.Util.jqmAjaxError ,
            'context': this
        }); 
    },
    
    CLASS_NAME: "Giscuit.Mobile.Control.Coords"
});

