/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this package in the file LICENSE.txt.
 *
 * @version    $Id: Truepulse.js 2644 2012-05-07 12:25:16Z pavel.iacovlev $
 * @copyright  Copyright (c) 2012 VEC
 */

Giscuit.Map.prototype.gtEventListeners.push({
    'draw': function() {
        gt.control.truepulse = new Giscuit.Mobile.Control.Truepulse();
    }
});

/**
 * Class: Giscuit.Mobile.Control.Truepulse
 * 
 *  Inherits from:
 *   - <Giscuit.Control>
 */
Giscuit.Mobile.Control.Truepulse = OpenLayers.Class(Giscuit.Control, {
    
    initialize: function (options) {
        gt.control.serial.events.register("read", this, function(evt) {
            debug.info(evt);
            this.read(evt);
        });
        
        //
        Giscuit.Control.prototype.initialize.apply(this, [options]);
    },
    
    read: function(line) {
        line = line.split(',');

        var result = {
            'mode': 'hd',
            'hd': parseFloat(line[2]),
            'az': parseFloat(line[4]),
            'inc': parseFloat(line[6]),
            'sl': parseFloat(line[8])   
        };
        
        if(! gt.control.editgeom.active) {
            Giscuit.Util.jqmMessage(gt.translate._('enableEditingTool'));        
            return false;
        }
        
        //
        if(result.mode == 'hd' &&  gt.control.geolocation.point) {
            //
            var distance = result.hd;
            var angle = result.az;
            var point = gt.control.geolocation.point.geometry.clone();
            
            //
            var addControl = gt.control.editgeom.controls.addControl;
            if(! addControl.active) {
                addControl.activate();
            }
            
            //
            if(gt.config.units == 'dd') {
                var sm = new OpenLayers.Projection("EPSG:900913");
                point.transform(gt.map.projection, sm);
                var newPoint = Giscuit.Util.cogoAngleDistance(point, distance, angle);
                newPoint.transform(sm, gt.map.projection);
            } else {
                var newPoint = Giscuit.Util.cogoAngleDistance(point, distance, angle);
            }
            
            //
            addControl.insertXY(newPoint.x, newPoint.y);
            
            return true;
        } else {
            Giscuit.Util.jqmMessage(gt.translate._('enableGeolocationTool'));
            return false;
        }
        
    },

    CLASS_NAME: "Giscuit.Mobile.Control.Truepulse"
});