/**
 * prettyDate
 */
Giscuit.Util.prettyDate = function (time) {
    var date = new Date(time);
    var now = new Date();
    
    if (date < now) {
        var diff = ((now.getTime() - date.getTime()) / 1000);
    } else {
        var diff = ((date.getTime() - now.getTime()) / 1000);
    }
    var day_diff = Math.floor(diff / 86400);
        
    if ( isNaN(day_diff) || day_diff < 0)
        return;
            
    return day_diff == 0 && (
            diff < 60 && gt.translate._('fewSeconds') ||
            diff < 120 && gt.translate._('1minute') ||
            diff < 3600 && Math.floor( diff / 60 ) + ' ' + gt.translate._('minutes') ||
            diff < 7200 && gt.translate._('1hour') ||
            diff < 86400 && Math.floor( diff / 3600 ) + ' ' + gt.translate._('hours')) ||
        day_diff == 1 && gt.translate._('1day') ||
        day_diff < 7 && day_diff + ' ' + gt.translate._('days') ||
        day_diff < 31 && Math.ceil( day_diff / 7 ) + ' ' + gt.translate._('weeks') ||
        day_diff >= 31 && Math.floor( day_diff / 31 ) + ' ' + gt.translate._('months');
}

/**
 * parseDate
 */
Giscuit.Util.parseDate = function(val) {
    if(gt.config.dateFormat == 'german') {
        val = val.split('.');
        var tmp = val[0];
        val[0] = val[1];
        val[1] = tmp;
        val = val.join('.');
        
        if(val[val.length -1 ] == 'T') {
            val = val.split(' ');
            val[val.length - 1] = '';
            val = val.join(' ');
        }
    }
    
    return new Date(strtotime(val) * 1000);
};

/**
 * formatDate
 */
Giscuit.Util.formatDate = function(date, format) {
    return dateFormat(date, format);
};

/**
 * text2cal
 */
Giscuit.Util.text2cal = function(textEl, dateInstances) {
    var Event = YAHOO.util.Event,
        Dom = YAHOO.util.Dom;
        
    //
    var calMenu = new YAHOO.widget.Overlay(textEl.id + '-calendarmenu', {visible: false});
    var calBtn = new YAHOO.widget.Button({ 
        type: 'menu', 
        id: textEl.id + '-calendarpicker', 
        menu: calMenu, 
        container: textEl.id + '-element'
    });
    calBtn.get('element').firstChild.firstChild.style.background = 'url(' + gt.config.httpImagePath + '/calendar.gif) center center no-repeat';
    calBtn.get('element').style.marginBottom = '-4px';
    calBtn.on('appendTo', function () {
        calMenu.setBody('&#32;');
        calMenu.body.id = textEl.id + '-calendarcontainer';
    });
    
    //
    if (! dateInstances) {
        dateInstances = [calMenu, calBtn];
    } else {
        dateInstances.push(calMenu, calBtn);
    }
    
    //
    var onCalBtnClick = function (evt) {
        startWeekday = 1;
        if(gt.config.dateFormat == 'sqlMdy') {
            startWeekday = 0;
        }
        
        YAHOO.widget.CalendarNavigator.DEFAULT_CONFIG.strings.year = gt.translate._('year');
        YAHOO.widget.CalendarNavigator.DEFAULT_CONFIG.strings.month = gt.translate._('month');
        YAHOO.widget.CalendarNavigator.DEFAULT_CONFIG.strings.submit = gt.translate._('submit');
        YAHOO.widget.CalendarNavigator.DEFAULT_CONFIG.strings.cancel = gt.translate._('cancel');
        
        var cal = new YAHOO.widget.Calendar(textEl.id + '-buttoncalendar', calMenu.body.id, {
            navigator: true,
            START_WEEKDAY: startWeekday,
            MONTHS_LONG: gt.translate._('monthsString').split(','),
            WEEKDAYS_SHORT: gt.translate._('weekdaysString').split(',')
        });
        dateInstances.push(cal);
        
        cal.select(Giscuit.Util.parseDate(textEl.value));
        
        cal.render();
        
        cal.selectEvent.subscribe(function (type, args) {
            var date;
            if (args) {
                date = args[0][0];
                date = new Date(date[0], date[1] - 1, date[2]);
                textEl.value = YAHOO.util.Date.format(date, {format: gt.config.yuiDateFormat});
            }
            calMenu.hide();
        });
        
        Event.on(calMenu.element, 'keydown', function (evt) {
            if (Event.getCharCode(evt) === 27) {
                calMenu.hide();
                this.focus();
            }
        }, null, this);
        
        calMenu.align();
        
        calBtn.unsubscribe('click', onCalBtnClick, dateInstances);
    };
    
    //
    calBtn.on('click', onCalBtnClick, dateInstances);
};

/**
 * http://blog.stevenlevithan.com/archives/date-time-format
 * 
 * dateFormat(now, "dddd, mmmm dS, yyyy, h:MM:ss TT");
 */
var dateFormat=function(){var k=/d{1,4}|m{1,4}|yy(?:yy)?|([HhMsTt])\1?|[LloSZ]|"[^"]*"|'[^']*'/g,l=/\b(?:[PMCEA][SDP]T|(?:Pacific|Mountain|Central|Eastern|Atlantic) (?:Standard|Daylight|Prevailing) Time|(?:GMT|UTC)(?:[-+]\d{4})?)\b/g,t=/[^-+\dA-Z]/g,d=function(a,c){a=String(a);for(c=c||2;a.length<c;)a="0"+a;return a};return function(a,c,h){var f=dateFormat;1==arguments.length&&("[object String]"==Object.prototype.toString.call(a)&&!/\d/.test(a))&&(c=a,a=void 0);a=a?new Date(a):new Date;if(isNaN(a))throw SyntaxError("invalid date");
c=String(f.masks[c]||c||f.masks["default"]);"UTC:"==c.slice(0,4)&&(c=c.slice(4),h=!0);var b=h?"getUTC":"get",g=a[b+"Date"](),n=a[b+"Day"](),j=a[b+"Month"](),p=a[b+"FullYear"](),e=a[b+"Hours"](),q=a[b+"Minutes"](),r=a[b+"Seconds"](),b=a[b+"Milliseconds"](),m=h?0:a.getTimezoneOffset(),s={d:g,dd:d(g),ddd:f.i18n.dayNames[n],dddd:f.i18n.dayNames[n+7],m:j+1,mm:d(j+1),mmm:f.i18n.monthNames[j],mmmm:f.i18n.monthNames[j+12],yy:String(p).slice(2),yyyy:p,h:e%12||12,hh:d(e%12||12),H:e,HH:d(e),M:q,MM:d(q),s:r,
ss:d(r),l:d(b,3),L:d(99<b?Math.round(b/10):b),t:12>e?"a":"p",tt:12>e?"am":"pm",T:12>e?"A":"P",TT:12>e?"AM":"PM",Z:h?"UTC":(String(a).match(l)||[""]).pop().replace(t,""),o:(0<m?"-":"+")+d(100*Math.floor(Math.abs(m)/60)+Math.abs(m)%60,4),S:["th","st","nd","rd"][3<g%10?0:(10!=g%100-g%10)*g%10]};return c.replace(k,function(a){return a in s?s[a]:a.slice(1,a.length-1)})}}();
dateFormat.masks={"default":"ddd mmm dd yyyy HH:MM:ss",shortDate:"m/d/yy",mediumDate:"mmm d, yyyy",longDate:"mmmm d, yyyy",fullDate:"dddd, mmmm d, yyyy",shortTime:"h:MM TT",mediumTime:"h:MM:ss TT",longTime:"h:MM:ss TT Z",isoDate:"yyyy-mm-dd",isoTime:"HH:MM:ss",isoDateTime:"yyyy-mm-dd'T'HH:MM:ss",isoUtcDateTime:"UTC:yyyy-mm-dd'T'HH:MM:ss'Z'"};dateFormat.i18n={dayNames:"Sun Mon Tue Wed Thu Fri Sat Sunday Monday Tuesday Wednesday Thursday Friday Saturday".split(" "),monthNames:"Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec January February March April May June July August September October November December".split(" ")};
Date.prototype.format=function(k,l){return dateFormat(this,k,l)};

/**
 * strtotime, http://phpjs.org/functions/strtotime/
 * 
 * strtotime('2009-05-04 08:30:00');
 */
function strtotime(b,d){function h(a){var b=a.split(" ");a=b[0];var c=b[1].substring(0,3),d=/\d+/.test(a),b=("last"===a?-1:1)*("ago"===b[2]?-1:1);d&&(b*=parseInt(a,10));if(f.hasOwnProperty(c))return e["set"+f[c]](e["get"+f[c]]()+b);if("wee"===c)return e.setDate(e.getDate()+7*b);if("next"===a||"last"===a)d=b,c=j[c],"undefined"!==typeof c&&(c-=e.getDay(),0===c?c=7*d:0<c&&"last"===a?c-=7:0>c&&"next"===a&&(c+=7),e.setDate(e.getDate()+c));else if(!d)return!1;return!0}if(!b)return null;b=b.trim().replace(/\s{2,}/g,
" ").replace(/[\t\r\n]/g,"").toLowerCase();var a;if("now"===b)return null===d||isNaN(d)?(new Date).getTime()/1E3|0:d|0;if(!isNaN(parse=Date.parse(b)))return parse/1E3|0;if("now"===b)return(new Date).getTime()/1E3;if(!isNaN(a=Date.parse(b)))return a/1E3;if(a=b.match(/^(\d{2,4})-(\d{2})-(\d{2})(?:\s(\d{1,2}):(\d{2})(?::\d{2})?)?(?:\.(\d+)?)?$/))return new Date(0<=a[1]&&69>=a[1]?+a[1]+2E3:a[1],parseInt(a[2],10)-1,a[3],a[4]||0,a[5]||0,a[6]||0,a[7]||0)/1E3;var e=d?new Date(1E3*d):new Date,j={sun:0,mon:1,
tue:2,wed:3,thu:4,fri:5,sat:6},f={yea:"FullYear",mon:"Month",day:"Date",hou:"Hours",min:"Minutes",sec:"Seconds"};a=b.match(RegExp("([+-]?\\d+\\s(years?|months?|weeks?|days?|hours?|min|minutes?|sec|seconds?|sun\\.?|sunday|mon\\.?|monday|tue\\.?|tuesday|wed\\.?|wednesday|thu\\.?|thursday|fri\\.?|friday|sat\\.?|saturday)|(last|next)\\s(years?|months?|weeks?|days?|hours?|min|minutes?|sec|seconds?|sun\\.?|sunday|mon\\.?|monday|tue\\.?|tuesday|wed\\.?|wednesday|thu\\.?|thursday|fri\\.?|friday|sat\\.?|saturday))(\\sago)?",
"gi"));if(!a)return!1;for(var g=0,k=a.length;g<k;g++)if(!h(a[g]))return!1;return e.getTime()/1E3};