/**
 * Giscuit
 *
 * LICENSE
 *
 * This source file is subject to the Giscuit license that is bundled
 * with this package in the file LICENSE.txt.
 *
 * @version    $Id: MobilePhotobox.js 1133 2011-03-14 16:12:16Z ue $
 * @copyright  Copyright (c) 2012 VEC
 */
/**
 * Method: Giscuit.Util.mobilePhotobox
 */

Giscuit.Util.mobilePhotobox = function (fileName, fileId, layerId) {
    
    var openImagePopup = function (photoboxHtml) {
        $.mobile.showPageLoadingMsg();
        
        $('.ui-page-active').append(photoboxHtml);
        
        var mobilePhotobox = $('.gtMobilePhotobox');
        mobilePhotobox.popup({positionTo: "window"});
        mobilePhotobox.bind({
            popupafterclose: function(event, ui) {
                mobilePhotobox.remove();
            }
        });
        
        $('.gtMobilePhotobox img').load(function() {
            mobilePhotobox.popup("open");
            $.mobile.hidePageLoadingMsg();
        });
        
        $('.gtMobilePhotobox a').button();
    }
    
    var photoboxHtml = '<div data-role="popup" class="gtMobilePhotobox">' +
        '<a href="javascript: void(0);" data-rel="back" data-role="button" data-icon="delete" ' +
        'data-iconpos="notext" class="ui-btn-right">' + gt.translate._('close') + '</a>';
    
    if (gt.control.offline.isOnline) {
        photoboxHtml += '<img src="' + gt.config.httpPath + '/uploads/index/id/' + fileId + '" title="' + fileName + '">' +
            '</div>';
        
        openImagePopup(photoboxHtml);
    } else {
        var filesTable = new Giscuit.Util.Db.Files({tableName: 'files_' + layerId});
        
        filesTable.read({
            id: fileId,
            callback: function(result) {
                //
                var fileInfo = result.files[0];
                var extension = fileInfo['name'].split('.').pop();
                
                photoboxHtml += '<img src="' + fileInfo['data'] + '" title="' + fileInfo['name'] + '">' +
                    '</div>';
                
                openImagePopup(photoboxHtml);
            }
        });
    }
    
};