<?php

class ChpassControllerTest extends Giscuit_Test_PHPUnit_ControllerTestCase
{
    protected $_newPassParams = array (
        'oldpassword' => '123456',
        'password' => '1234567',
        'confirm_password' => '1234567',
        'chpass' => 'Change password'
    );
    
    protected $_oldPassParams = array (
        'oldpassword' => '1234567',
        'password' => '123456',
        'confirm_password' => '123456',
        'chpass' => 'Change password'
    );
    
    protected $_wrongPassParams = array (
        'oldpassword' => 'wrongpassword',
        'password' => '',
        'confirm_password' => 'noMatch',
        'chpass' => 'Change password'
    );
    
    protected $_tempUser = array (
        'account' => 'test@giscuit.com' , 
        'password' => '1234567'
    );
    
    public function testIndexAction()
    {
        $this->_testLoginActionSuccess();
        
        $this->dispatch('/' . $this->_language . '/default/chpass');
        $this->assertModule('default');
        $this->assertController('chpass');
        $this->assertAction('index');
        $this->assertResponseCode(200);
        $this->assertQuery('form#gtChpassForm');
    }
    
    
    public function testChangePassActionSuccess()
    {
        $translate = Zend_Registry::get('Zend_Translate');
        
        $this->_testLoginActionSuccess();
        
        $this->request->setMethod('POST')->setPost($this->_newPassParams);
        $this->dispatch('/' . $this->_language . '/default/chpass');
        
        $response = Zend_Json::decode($this->getResponse()->getBody());
        $this->assertEquals($response['replyCode'], 200);
        $this->assertEquals($response['result'], $translate->_('passwordChanged'));
    }
    
    
    public function testLoginAfterChangePassword()
    {
        $this->request->setMethod('POST')->setPost($this->_tempUser);
        $this->dispatch('/' . $this->_language . '/default/auth');
                
        $this->assertObjectHasAttribute('id', Zend_Auth::getInstance()->getIdentity());
    }
    
    public function testSetOldPasswordBack()
    {
        $translate = Zend_Registry::get('Zend_Translate');
           
        $this->testLoginAfterChangePassword();
        $this->clear();
        
        $this->request->setMethod('POST')->setPost($this->_oldPassParams);
        $this->dispatch('/' . $this->_language . '/default/chpass');
        
        $response = Zend_Json::decode($this->getResponse()->getBody());
        $this->assertEquals($response['replyCode'], 200);
        $this->assertEquals($response['result'], $translate->_('passwordChanged'));
    }
    
    public function testChangePassActionFailure()
    {
        $translate = Zend_Registry::get('Zend_Translate');
        
        $this->_testLoginActionSuccess();
        
        $this->request->setMethod('POST')->setPost($this->_wrongPassParams);
        $this->dispatch('/' . $this->_language . '/default/chpass');
        
        $response = Zend_Json::decode($this->getResponse()->getBody());
        $this->assertEquals($response['replyCode'], 200);
        $this->assertNotNull($response['form']);
    }
}