<?php

class InitTest extends Giscuit_Test_PHPUnit_ControllerTestCase
{
    protected $_layerName = 'Worldboundaries';
    
    protected function _getIdFromClass($layer)
    {
        $layersTable = new Giscuit_Db_Table_Layers();                
        $row = $layersTable->getItems(array('whereClass' => $layer));
        foreach($row as $r) {
            $id = $r['id'];
        }        
        return $id;
    }
    
    public function testConfig()
    {
        $config = Zend_Registry::get('config');
        
        $this->assertEquals($config->map->srid, 4326);
        $this->assertEquals($config->map->units, 'dd');
    }
    
    public function testSetLayerEditable()
    {
        $this->_testLoginActionSuccess();
        
        $rulesTable = new Giscuit_Db_Table_Rules();
        $layersTable = new Giscuit_Db_Table_Layers();
        $layerPublishTable = new Giscuit_Db_Table_LayerPublish();
        
        //Delete old rules if exist
        $rulesTable->delete("resource = '" . $this->_layerName . "_layer'");
        
        //Add new rules
        $id = $rulesTable->addItem();
        $rulesTable->editItem($id, (object) array('column' => 'role', 'data' => 'admin'));
        $rulesTable->editItem($id, (object) array('column' => 'resource', 'data' => $this->_layerName . '_layer'));
        $rulesTable->editItem($id, (object) array('column' => 'privilege', 'data' => 'view'));
        $rulesTable->editItem($id, (object) array('column' => 'group', 'data' => 'layer'));
        
        $id = $rulesTable->addItem();
        $rulesTable->editItem($id, (object) array('column' => 'role', 'data' => 'admin'));
        $rulesTable->editItem($id, (object) array('column' => 'resource', 'data' => $this->_layerName . '_layer'));
        $rulesTable->editItem($id, (object) array('column' => 'privilege', 'data' => 'edit'));
        $rulesTable->editItem($id, (object) array('column' => 'group', 'data' => 'layer'));
        
        //Set permissions for layer
        $permissionData = array (
            'resource' => $this->_layerName . '_layer',
            'priv_view' => 'view',
            'priv_editgeom' => 'edit',
            'priv_ows' => 'view'
        );
        $where = $layersTable->getAdapter()->quoteInto('class = ?', $this->_layerName);
        
        $layersTable->update($permissionData, $where);
        
        //Set WMS and WFS accesses
        $layerId = $this->_getIdFromClass($this->_layerName);
        $publishRow = $layerPublishTable->find($layerId)->current();
        
        $publishRow->wms_public = 't';
        $publishRow->wms_private = 't';
        $publishRow->wfs_public = 't';
        $publishRow->wfs_private = 't';
                
        $publishRow->save();

    }
}